<?
if (!isset($IPS_VARIABLE))     $IPS_VARIABLE    ="";
	//----------------- Ferengi Masters Terminverwaltung V2.x -------------------

	//Ablageort fr termine.txt
 	$filename = IPS_GetKernelDir()."media\\termine.txt";
	//Variable fr den Pageindex des Dashboards
	$id_tab_index     = 15114;
	//Terminarten
  $term_art_text_neu = "Sonstiges|Geburtstag|Hausarbeit|Arbeit|Gartenarbeit";
   
	//---------------------- Prfen ob schon installiert ------------------------

   $script_info = IPS_GetObject($IPS_SELF);
   $parent_info = IPS_GetObject($script_info['ParentID']);

	if($parent_info['ObjectName'] != ".Terminverwaltung")
	{

		//--------------------------- Kategorie anlegen --------------------------

		$id_kat = IPS_CreateCategory();
		IPS_SetName($id_kat, ".Terminverwaltung");

		//------------------- Scripte in Kategorie verschieben -------------------

   	IPS_SetParent($IPS_SELF, $id_kat); //in Root verschieben

		//--------------------------- Variablen anlegen --------------------------

	  	//legt Variablen vom Typ Boolean an (0)
		$var_name = array(
		'term',
		'term_mod1_ansage',
		'term_mod2_ansage',
		'term_mod3_ansage',
		'term_mod4_ansage',
		'term_mod5_ansage',
	 	'term_mod6_ansage',
		'term_aktiv',
	 	'term_einmalig',
		'term_mo',
	 	'term_di',
		'term_mi',
		'term_do',
		'term_fr',
		'term_sa',
		'term_so',
		'term_14tag_ger',
		'term_14tag_ung',
 		'term_monatlich',
		'term_jaerlich',
		'term_loe',
 		'term_anzei',
		'term_erin_vis'
		);

		$counter = count($var_name); // Werte zhlen
 		for ($x=0; $x<=$counter-1; $x++)
 		{
 			$var_id = IPS_CreateVariable(0);
   		IPS_SetName($var_id,$var_name[$x]);
   		IPS_SetParent($var_id, $id_kat);
	 	}

		//legt Variablen vom Typ Integer an (1)
  		$var_name = array(
		'terminmodus',
		'term_erin',
		'term_art',
		'term_art_liste',
		'kalenderwoche',
		'counter_summe',
		'counter');

		$counter = count($var_name); // Werte zhlen
 		for ($x=0; $x<=$counter-1; $x++)
 		{
 			$var_id = IPS_CreateVariable(1);
   		IPS_SetName($var_id,$var_name[$x]);
   		IPS_SetParent($var_id, $id_kat);
 		}

		//legt Variablen vom Typ String an (3)
		$var_name = array(
		'term_inhalt',
		'term_aktuell',
		'term_meldung',
		'term_trigger',
		'term_trigger_para',
		'term_stunde',
		'term_minute',
		'term_tag',
		'term_monat',
		'term_erin_text',
 		'term_erin_anzeige',
		'term_art_text',
		'term_art_liste_text',
		'datum',
		'termine');

		$counter = count($var_name); // Werte zhlen
 		for ($x=0; $x<=$counter-1; $x++)
 		{
 			$var_id = IPS_CreateVariable(3);
   		IPS_SetName($var_id,$var_name[$x]);
   		IPS_SetParent($var_id, $id_kat);
 		}
 		sleep(3);
	}

   //------------------------- bentigte Variablen -----------------------------

 	$time = time();
 	$hrs = (integer)date("H", $time);
 	$min = (integer)date("i", $time);
 	$sec = (integer)date("s", $time);

   $script_info = IPS_GetObject($IPS_SELF);
   $id_kat	    = $script_info['ParentID']; //Kategorie ID ermitteln

	foreach(
  	array(
	 'termine',
    'terminmodus',
	 'counter_summe',
	 'counter',
 	 'datum',
 	 'kalenderwoche',
	 'term_aktuell',
	 'term_meldung',
	 'term',
	 'term_mod1_ansage',
	 'term_mod2_ansage',
	 'term_mod3_ansage',
	 'term_mod4_ansage',
	 'term_mod5_ansage',
	 'term_mod6_ansage',
	 'term_einmalig',
	 'term_loe',
	 'term_mo',
	 'term_di',
	 'term_mi',
	 'term_do',
	 'term_fr',
	 'term_sa',
	 'term_so',
	 'term_14tag_ger',
 	 'term_14tag_ung',
	 'term_monatlich',
    'term_jaerlich',
	 'term_trigger',
	 'term_trigger_para',
 	 'term_aktiv',
 	 'term_erin',
 	 'term_erin_vis',
 	 'term_erin_text',
 	 'term_erin_anzeige',
 	 'term_anzei',
 	 'term_art',
 	 'term_art_text',
 	 'term_art_liste',
 	 'term_art_liste_text',
  	 'term_stunde',
	 'term_minute',
	 'term_tag',
	 'term_monat',
 	 'term_inhalt'
  	) as $var)
	{
  		${'id_'.$var} = IPS_GetVariableIDByName($var, $id_kat);
	}

 	$term                = GetValueBoolean($id_term);
 	$term_aktuell        = GetValueString ($id_term_aktuell);
 	$terminmodus         = GetValueInteger($id_terminmodus);

	//nicht ndern !!!!
   $term_erin_text_neu = "keine|5 min|15 min|30 min|1 Stunde|1 Tag|2 Tage|1 Woche|2 Wochen";
   
	if(GetValueString($id_term_erin_text) != $term_erin_text_neu)
	{
	   SetValueString($id_term_erin_text, $term_erin_text_neu);
	}

	if(GetValueString($id_term_art_text) != $term_art_text_neu)
	{
	   SetValueString($id_term_art_text, $term_art_text_neu);
	}

	if (!isset($IPS_COMPONENT)) $IPS_COMPONENT="";

	//---------------- Start der Terminprfung ermglichen ----------------------

 	$timer_wert = IPS_GetScriptTimer($IPS_SELF);  //prfen ob Timer aktiv
 	if($timer_wert != 0)
 	{
   	//Timer aktiv
 	}
 	else
 	{
   	IPS_SetScriptTimer($IPS_SELF,60); //Timer jede Minute starten
 	}

	//Sekunden anpassen
 	$seconds = (integer)date("s");
 	if($seconds != 0)
 	{
   	IPS_SetScriptTimer($IPS_SELF,60 - $seconds);
 	}
 	else
 	{
   	IPS_SetScriptTimer($IPS_SELF,60);
 	}

	//mehrfachtriggern whrend einer Terminmodusansage verhindern
	if($IPS_SENDER == "TimerEvent" and $terminmodus !=0 and $terminmodus !=6) return;

 	//--------------------------- Termine ermitteln -----------------------------

	//Termine fr die einzelnen Modi vorlesen wenn $terminmodus != 0 ist
 	$terminmodus = GetValueInteger($id_terminmodus);

 	//bei Terminmodus == 6 durch Termineingabe weiter !!!
 	if($IPS_SENDER == "TimerEvent" or $terminmodus !=0)
 	{
   	//Termine fr den neuen Tag bereinigen und anzeigen 
   	if($hrs == 23 and $min == 59 or $hrs == 00 and $min == 01 or $terminmodus !=0)
   	{
      	SetValueBoolean($id_term, false); //Terminsymbol lschen
			SetValueString($id_termine, ""); //Terminanzeige WF und Dash lschen

		  	if($hrs == 00 and $min == 01)
			{
				SetValueInteger($id_kalenderwoche, (int)date("W"));
				SetValueString($id_datum, date("d.m.y"));
			}

			$var_bool = array
   	   (
      	$id_term,
      	$id_term_mod1_ansage,
      	$id_term_mod2_ansage,
      	$id_term_mod3_ansage,
      	$id_term_mod4_ansage,
      	$id_term_mod5_ansage
      	);

	      foreach($var_bool as $value) SetValueBoolean($value, false);
   	}

   	//Daten holen
   	$termfile = file_get_contents($filename); //Termine in Variable einlesen
   	$term_arr_komplett = explode("\r\n", $termfile); // nach Zeilenumbruch trennen und in array

		//Termine suchen
   	$erg       = "";
   	$term_para = 0;
   	$wo_heu    = 0;
   	$wo_mor    = 0;
   	$wf 		  = array();

   	foreach($term_arr_komplett as $key => $value) //alle Termine durchlaufen
	   {
   	   $term_arr = explode(",", $value); // einzelnen Datensatz in Daten zerlegen

			$term_einmalig   		= $term_arr[1];
	      $term_jaerlich   		= $term_arr[2];
   	   $term_mo         		= $term_arr[3];
      	$term_di         		= $term_arr[4];
      	$term_mi         		= $term_arr[5];
      	$term_do         		= $term_arr[6];
      	$term_fr         		= $term_arr[7];
      	$term_sa         		= $term_arr[8];
      	$term_so         		= $term_arr[9];
      	$term_aktiv      		= $term_arr[10];
      	$term_stunde     		= $term_arr[11];
      	$term_minute     		= $term_arr[12];
      	$term_tag         	= $term_arr[13];
      	$term_monat      		= $term_arr[14];
      	$term_loe	     		= $term_arr[16];
      	$term_14tag_ger	 	= $term_arr[19];
      	$term_14tag_ung	 	= $term_arr[20];
      	$term_erin			 	= $term_arr[21];
      	$term_anzei			 	= $term_arr[22];
      	$term_art			 	= $term_arr[23];
      	$term_monatlich   	= $term_arr[24];
      	$term_inhalt     		= $term_arr[25];
      	$term_trigger    		= $term_arr[26];
      	$term_trigger_para 	= $term_arr[27];

	      if($term_aktiv) //wenn aktiver Termin gefunden => prfen
   	   {
      	   //Timestamp von heute
         	$heute        = mktime (0,0,0,date("m"),date("d"),date("y"));
         	//Timestamp des Termins aus der for Schleife
				if($term_monatlich != 1) //kein Monatlicher Termin
				{
					$termin_dat   = mktime (0,0,0, $term_monat, $term_tag ,date("y"));
				}
				else //Monatlicher Termin
				{
					$termin_dat   = mktime (0,0,0, date("m"), $term_tag, date("y"));
				}
         	//schauen ob Termin auf heute($erg = 0) oder morgen fllt ($erg = -1)
         	$diff         = $heute-$termin_dat;
         	$erg          = $diff/((60*60)*24);
         	//heutigen Tag ermitteln
         	$tag          = (date("w"));


				//--------------------------- Erinnerung ---------------------------

				//"keine|5 min|15 min|30 min|1 Stunde|1 Tag|2 Tage|1 Woche|2 Wochen"
			   $erin_arr[1] = 5*60;
			   $erin_arr[2] = 15*60;
			   $erin_arr[3] = 30*60;
			   $erin_arr[4] = 60*60;
			   $erin_arr[5] = (1*24)*(60*60);
			   $erin_arr[6] = (2*24)*(60*60);
  			   $erin_arr[7] = (7*24)*(60*60);
  			   $erin_arr[8] = (14*24)*(60*60);
				
				if($term_erin != 0)
				{
				   //einmalige Termine
					if($term_einmalig)
					{
						$akt_timestamp  = mktime(date("H"),date("i"),0,date("m"),date("d"),date("y"));
        	   		$term_timestamp = mktime((int)$term_stunde,(int)$term_minute,0,(int)$term_monat, (int)$term_tag, date("y"));

	               //Termin ist im Januar und aktueller Monat ist Dezember
						if(date("m") == 12 and (int)$term_monat == 1)
						{
						   $term_timestamp = mktime((int)$term_stunde,(int)$term_minute,0,(int)$term_monat,(int)$term_tag, date("y")+1);
						}
	      			if($akt_timestamp - $term_timestamp+$erin_arr[$term_erin] == 0)
         			{
							$term_erin_anzeige = GetValueString($id_term_erin_anzeige);
							if($term_erin_anzeige != "")
							{
							   $term_erin_anzeige = $term_erin_anzeige."\n";
							}
	         			$term_erin_anzeige.= "[Einmalig], $term_arr[13].$term_arr[14], $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
         				SetValueString($id_term_erin_anzeige ,$term_erin_anzeige);
						  	SetValueBoolean($id_term_erin_vis, true);
         			}

         		}
					//wchentliche Termine
					if(!$term_einmalig and !$term_14tag_ger and !$term_14tag_ung and !$term_monatlich and !$term_jaerlich)
					{
      			   $wt_array_term = array($term_arr[3], $term_arr[4], $term_arr[5], $term_arr[6], $term_arr[7], $term_arr[8], $term_arr[9]);
						$wt_array_name = array('Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday');
   	
						$z = 0;
						foreach($wt_array_term as $key => $value)
						{
							if($value == 1)
						   {
							  $term_timestamp = strtotime("next $wt_array_name[$z] $term_stunde:$term_minute");
							}
						   $z++;
						}
						$akt_timestamp  = mktime(date("H"),date("i"),0,date("m"),date("d"),date("y"));
		   			if($akt_timestamp - $term_timestamp+$erin_arr[$term_erin] == 0)
         			{
							$term_erin_anzeige = GetValueString($id_term_erin_anzeige);
							if($term_erin_anzeige != "")
							{
							   $term_erin_anzeige = $term_erin_anzeige."\n";
							}
	         			$term_erin_anzeige.= "[Wchentlich], $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
     						SetValueString($id_term_erin_anzeige ,$term_erin_anzeige);
						  	SetValueBoolean($id_term_erin_vis, true);
         			}
	       		}
					//14tgige Termine
					if($term_14tag_ger or $term_14tag_ung)
					{
					  	$wt_array_term = array($term_arr[3], $term_arr[4], $term_arr[5], $term_arr[6], $term_arr[7], $term_arr[8], $term_arr[9]);
						$wt_array_name = array('Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday');

						$z = 0;
						foreach($wt_array_term as $key => $value)
						{
							if($value == 1)
						   {
							  $term_timestamp = strtotime("next $wt_array_name[$z] $term_stunde:$term_minute");
							}
						   $z++;
						}
						$akt_timestamp  = mktime(date("H"),date("i"),0,date("m"),date("d"),date("y"));
		   			if($akt_timestamp - $term_timestamp+$erin_arr[$term_erin] == 0)
         			{
							$term_erin_anzeige = GetValueString($id_term_erin_anzeige);
							if($term_erin_anzeige != "")
							{
							   $term_erin_anzeige = $term_erin_anzeige."\n";
							}
	         			$term_erin_anzeige.= "[14 Tgig], $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
         				SetValueString($id_term_erin_anzeige, $term_erin_anzeige);
						  	SetValueBoolean($id_term_erin_vis, true);
         			}
	       		}
					//monatliche Termine
					if($term_monatlich)
					{
						$akt_timestamp   = mktime(date("H"),date("i"),0,date("m"),date("d"),date("y"));
						if(date("m") != 1)
						{
		        	   	$term_timestamp1 = mktime((int)$term_stunde,(int)$term_minute,0, date("m")-1, (int)$term_tag,date("y"));
	      	   	}
	      	   	else
	      	   	{
        	   			$term_timestamp1 = mktime((int)$term_stunde,(int)$term_minute,0, 1,(int)$term_tag, date("y")-1);
        	   		}
        	   		$term_timestamp2 = mktime((int)$term_stunde,(int)$term_minute,0, date("m"), (int)$term_tag,date("y"));
						if(date("m") != 12)
						{
	        	   		$term_timestamp3 = mktime((int)$term_stunde,(int)$term_minute,0, date("m")+1, (int)$term_tag, date("y"));
	        	   	}
	        	   	else
	        	   	{
		        	   	$term_timestamp3 = mktime((int)$term_stunde,(int)$term_minute,0, 1, (int)$term_tag, date("y")+1);
		        	   }

	      			if($akt_timestamp - $term_timestamp1+$erin_arr[$term_erin] == 0 or
	      			   $akt_timestamp - $term_timestamp2+$erin_arr[$term_erin] == 0 or
							$akt_timestamp - $term_timestamp3+$erin_arr[$term_erin] == 0)
	       			{
        					$term_erin_anzeige = GetValueString($id_term_erin_anzeige);
							if($term_erin_anzeige != "")
							{
							   $term_erin_anzeige = $term_erin_anzeige."\n";
							}
	         			$term_erin_anzeige.= "[Monatlich], $term_arr[13]. Tag des Monats, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
         				SetValueString($id_term_erin_anzeige, $term_erin_anzeige);
						  	SetValueBoolean($id_term_erin_vis, true);
         			}
	       		}
   			   //jhrliche Termine
					if($term_jaerlich)
					{
						$akt_timestamp  = mktime(date("H"),date("i"),0,date("m"),date("d"),date("y"));
        	   		$term_timestamp = mktime(date("H"),date("i"),0,(int)$term_monat, (int)$term_tag, date("y"));

	               //Termin ist im Januar und aktueller Monat ist Dezember
						if(date("m") == 12 and (int)$term_monat == 1)
						{
						   $term_timestamp = mktime(date("H"),date("i"),0,(int)$term_monat,(int)$term_tag, date("y")+1);
						}
	      			if($akt_timestamp - $term_timestamp+$erin_arr[$term_erin] == 0)
         			{
	         			$term_erin_anzeige.= "[Jhrlich], $term_arr[13].$term_arr[14], $term_arr[25]";
         				SetValueString($id_term_erin_anzeige, $term_erin_anzeige);
						  	SetValueBoolean($id_term_erin_vis, true);
         			}
         		}


				}

  		      //------------------------------------------------------------------

	         //wiederkehrende Wchentliche Termine die auf heute fallen prfen
   	      if ($tag == 0 and $term_so == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
					 $tag == 1 and $term_mo == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
        	       $tag == 2 and $term_di == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
					 $tag == 3 and $term_mi == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
         	    $tag == 4 and $term_do == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
					 $tag == 5 and $term_fr == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
            	 $tag == 6 and $term_sa == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0)
         	{
            	$erg 	 	= 0;
    	        	$wo_heu  = 1;
      	   }
     	      //wiederkehrende 14 Tgige Termine an geraden Wochen die auf heute fallen prfen
   	      if ($tag == 0 and $term_so == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
					 $tag == 1 and $term_mo == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
        	       $tag == 2 and $term_di == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
					 $tag == 3 and $term_mi == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
         	    $tag == 4 and $term_do == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
					 $tag == 5 and $term_fr == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
            	 $tag == 6 and $term_sa == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0)
         	{
					if((date("W") % 2)==0)
					{
					 	//gerade Woche
						$erg 	 	= 0;
    	        		$wo_heu  = 1;
    	        	}
      	   }
      	   //wiederkehrende 14 Tgige Termine an ungeraden Wochen die auf heute fallen prfen
   	      if ($tag == 0 and $term_so == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 1 and $term_mo == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
        	       $tag == 2 and $term_di == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 3 and $term_mi == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 4 and $term_do == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 5 and $term_fr == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
            	 $tag == 6 and $term_sa == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1)
         	{
					if((date("W") % 2)!=0)
					{
						//ungerade Woche
    	        		$erg 	 	= 0;
	            	$wo_heu  = 1;
	            }
				}
				//Termin zur Uhrzeit (Einmalig, Wchentlich, Monatlich) => Script ID aufrufen, wenn vorhanden
	      	if($erg == 0 and $hrs == $term_stunde and	$min == $term_minute and $term_jaerlich != true)
         	{
              	SetValueString($id_term_aktuell, $term_inhalt); //Variable triggert Sprachausgabe
					IPS_Sleep(500);
					
					if((int)$term_trigger != 0 and $terminmodus == 0)
					{
						IPS_RunScriptEx((int)$term_trigger,array("term_trigger_para" => $term_trigger_para));
					}
         	}
				//wiederkehrende Wchentliche Termine die auf morgen fallen prfen
				if ($tag == 0 and $term_mo == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
            	 $tag == 1 and $term_di == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
					 $tag == 2 and $term_mi == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
         	  	 $tag == 3 and $term_do == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
					 $tag == 4 and $term_fr == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
             	 $tag == 5 and $term_sa == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0 or
					 $tag == 6 and $term_so == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 0)
         	{
            	$erg 	 	= -1;
            	$wo_mor  =  1;
         	}
         	//wiederkehrende 14 Tgige Termine an geraden Wochen die auf morgen fallen prfen
				if ($tag == 1 and $term_di == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
					 $tag == 2 and $term_mi == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
         	  	 $tag == 3 and $term_do == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
					 $tag == 4 and $term_fr == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
             	 $tag == 5 and $term_sa == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0 or
					 $tag == 6 and $term_so == 1 and $term_14tag_ger == 1 and $term_14tag_ung == 0)
				{
					if ((date("W") % 2)==0)
					{
						//gerade Woche
				   	$erg 	 	= -1;
		           	$wo_mor  =  1;
					}
      	   }
				//wiederkehrende 14 Tgige Termine an geraden Wochen die auf morgen fallen prfen
				if ($tag == 0 and $term_mo == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1)
  				{
  				   $morgen = mktime(0, 0, 0, date("m"), date("d")+1, date("Y"));
      	   	if (((date("W", $morgen) % 2)==0))
					{
						//gerade Woche
				  		$erg 	 	= -1;
		           	$wo_mor  =  1;
		         }
      	   }
         	//wiederkehrende 14 Tgige Termine an ungeraden Wochen die auf morgen fallen prfen
				if ($tag == 1 and $term_di == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 2 and $term_mi == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
         	  	 $tag == 3 and $term_do == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 4 and $term_fr == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
             	 $tag == 5 and $term_sa == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1 or
					 $tag == 6 and $term_so == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1)
				{
					if ((date("W") % 2)!=0)
					{
    	        	   //ungerade Woche
  	        	   	$erg 	 	= -1;
	            	$wo_mor  =  1;
    	         }
      	   }
				//wiederkehrende 14 Tgige Termine an ungeraden Wochen die auf morgen fallen prfen
				if ($tag == 0 and $term_mo == 1 and $term_14tag_ger == 0 and $term_14tag_ung == 1)
  				{
  				   $morgen = mktime(0, 0, 0, date("m"), date("d")+1, date("Y"));
      	   	if (((date("W", $morgen) % 2)!=0))
				  	{
    	        	   //ungerade Woche
  				  		$erg 	 	= -1;
	            	$wo_mor  =  1;
    	         }
      	   }
         	//jhrlicher Termin immer um 00:01 => Script ID aufrufen, wenn vorhanden
				if ($erg == 0 and $term_jaerlich and $hrs == 00 and $min == 01)
         	{
					if((int)$term_trigger != 0 and $terminmodus == 0)
					{
						IPS_RunScriptEx((int)$term_trigger,array("term_trigger_para" => $term_trigger_para));	            	
					}
				}
				//automatisches lschen von einmaligen Terminen
				if ($erg == 0 and $term_einmalig and $term_loe and $hrs == 23 and $min == 59)
         	{
         		unset ($term_arr_komplett[$key]);
   				$term_neu_komplett = implode("\r\n", $term_arr_komplett); // in String zurck
   				$handle=fopen($filename, "w");
   				fwrite($handle,$term_neu_komplett);
   				fclose($handle);
				}
         	//fr die Bereinigung Designer 
         	if($hrs == 23 and $min == 59 or $hrs == 00 and $min == 01 or $terminmodus !=0)
         	{
					//Formatierung
           		$term_stunde = sprintf("%02s", $term_stunde);
               $term_minute = sprintf("%02s", $term_minute);
           		$term_tag	 = sprintf("%02s", $term_tag);
               $term_monat  = sprintf("%02s", $term_monat);

            	if($erg == 0 or $erg == -1)
            	{
	               if($wo_heu != 1 and $wo_mor != 1)
   	            {
      	            $term_text = $term_tag.".";
	        	         $term_text.= $term_monat.". ";
							if($term_monatlich == 1 and $erg == 0) //Monatlicher Termin heute
							{
								$term_text = $term_tag.".";
		        	         $term_text.= date("m").". ";
							}
							elseif($term_monatlich == 1 and $erg == -1) //Monatlicher Termin morgen
							{
	      	            $term_text = date("d.m. ", strtotime("+1 day"));
							}
	           	   }
   	            else //wchentliche Termine heute und morgen
      	         {
							if($wo_heu == 1 and $wo_mor == 1 and $term_anzei) //wchentlicher Termin heute und morgen
							{
								//heute
								$term_text = date("d.");
         	         	$term_text.= date("m. ");
								$term_text.= $term_stunde.".";
	                     $term_text.= $term_minute." Uhr ";
								$term_text.= $term_inhalt;
								$wf[] = $term_text;
								sort($wf);
								//morgen
								$term_wf = implode("\n", $wf);
         	         	$term_text = date("d.m. ", strtotime("+1 day"));
								$term_text.= $term_stunde.".";
	                     $term_text.= $term_minute." Uhr ";
               			$term_text.= $term_inhalt;
								$wf[] = $term_text;
								sort($wf);
								$term_wf = implode("\n", $wf);
								SetValueString($id_termine, $term_wf);
							}
							elseif($wo_heu == 1 and $wo_mor != 1 and $term_anzei) //wchentlicher Termin heute
							{
								$term_text = date("d.");
         	         	$term_text.= date("m. ");
     	         			$term_text.= $term_stunde.".";
	                     $term_text.= $term_minute." Uhr ";
         	         	$term_text.= $term_inhalt;
        	         		$wf[] = $term_text;
								sort($wf);
								$term_wf = implode("\n", $wf);
								SetValueString($id_termine, $term_wf);
							}
							elseif($wo_heu != 1 and $wo_mor == 1 and $term_anzei) //wchentlicher Termin morgen
							{
						   	$term_text = date("d.m. ", strtotime("+1 day"));
								$term_text.= $term_stunde.".";
	                     $term_text.= $term_minute." Uhr ";
               			$term_text.= $term_inhalt;
								$wf[] = $term_text;
								sort($wf);
								$term_wf = implode("\n", $wf);
								SetValueString($id_termine, $term_wf);
							}
            	   }

						//Formatierung
                  if(!$term_jaerlich)   $term_text.= $term_stunde.".";
	               if(!$term_jaerlich)   $term_text.= $term_minute." Uhr ";

						if($wo_heu != 1 and $term_anzei and $wo_mor != 1)
						{
	               	$term_text.= $term_inhalt;
							$wf[] = $term_text;

							//WebFront & Dashboard Ausgabe
							sort($wf);
							$term_wf = implode("\n", $wf);
							SetValueString($id_termine, $term_wf);
						}
						
	               $wo_heu = 0; // falls wiederkehrender Termin, zurcksetzen
  	               $wo_mor = 0; // falls wiederkehrender Termin, zurcksetzen
   	         }
      	   }

  	         //jhrliche Termine ermitteln
   	      if((int)$term_arr[11] != 0) //einmaliger Termin zu einer bestimmten Zeit
      	   {
         	   $jetzt    = mktime (date("H"),date("i"),0,date("m"),date("d"),date("y"));
            	$term_ber = mktime ((int)$term_arr[11],(int)$term_arr[12],0,date("m"),date("d"),date("y"));
         	}
         	else  //jhrlicher Termin
        		{
            	$term_ber =0;
            	$jetzt    =0;
         	}
     	   	//Terminmodus 1 
      	   if($terminmodus == 1 and $erg == -1)
     		   {
         	   SetValueBoolean($id_term_mod1_ansage, true);
	            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
					TTS_Play(1,"Achtung Termin morgen".$term_inhalt,"meldung",3);
	            //===> Sprachausgabe anpassen, Ende
         	}
   	      //Terminmodus 2 
      	   if($terminmodus == 2 and $erg == -1)
         	{
            	SetValueBoolean($id_term_mod2_ansage, true);
	            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
					TTS_Play(3,"Achtung Termin morgen  .$term_inhalt","meldung",2);
	            //===> Sprachausgabe anpassen, Ende
         	}
         	//Terminmodus 3 
         	if($terminmodus == 3 and $erg == 0 and $term_ber >= $jetzt)
         	{
            	SetValueBoolean($id_term_mod3_ansage, true);
            	sleep(1);
	            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
					TTS_Play(3,"Achtung Termin heute  .$term_inhalt","meldung",2);
	            //===> Sprachausgabe anpassen, Ende
         	}
         	//Terminmodus 4 
         	if($terminmodus == 4 and $erg == 0 and $term_ber >= $jetzt)
         	{
            	SetValueBoolean($id_term_mod4_ansage, true);
	            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
					TTS_Play(1,"Achtung Termin heute ".$term_inhalt,"meldung",2);
	            //===> Sprachausgabe anpassen, Ende
         	}
         	//Terminmodus 5
         	if($terminmodus == 5 and $erg == 0 and $term_ber >= $jetzt)
         	{
            	SetValueBoolean($id_term_mod5_ansage, true);
	            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
					TTS_Play(2,"Achtung Termin heute  .$term_inhalt","meldung",2);
	            //===> Sprachausgabe anpassen, Ende
         	}
         }
   	} // foreach Schleife beenden

		//Feiertage
 		class Feiertag
		{
  			function getEasterSundayTime($year)
			{
    			$p = floor($year/100);
    			$r = floor($year/400);
    			$o = floor(($p*8+13)/25)-2;
    			$w = (19*($year%19)+(13+$p-$r-$o)%30)%30;
    			$e = ($w==29?28:$w);
    			if ($w==28&&($year%19)>10) $e=27;
    			$day = (2*($year%4)+4*($year%7)+6*$e+(4+$p-$r)%7)%7+22+$e;
    			$month = ($day>31?4:3);
    			if ($day>31) $day-=31;
    			return mktime(0, 0, 0, $month, $day, $year);
  			}
  			function getHolidays($year)
			{
    			$time = $this->getEasterSundayTime($year);
				$days[""] 									= 0;
     			$days["Neujahr"] 							= mktime(0, 0, 0, 1, 1, $year);
    			//$days["Heilige 3 Knige"] 			= mktime(0, 0, 0, 1, 6, $year);
    			$days["Karfreitag"] 						= $time-(86400*2);
    			$days["Ostersonntag"] 					= $time;
				$days["Ostermontag"] 					= $time+(86400);
    			$days["Tag der Arbeit"]        		= mktime(0, 0, 0, 5, 1, $year);
    			$days["Christi Himmelfahrt"] 			= $time+(86400*39);
    			$days["Pfingstsonntag"] 				= $time+(86400*49);
    			$days["Pfingstmontag"] 					= $time+(86400*50);
    			//$days["Fronleichnam"] 				= $time+(86400*60);
    			//$days["Maria Himmelfahrt"] 			= mktime(0, 0, 0, 08, 15, $year); 
    			$days["Tag der deutschen Einheit"] 	= mktime(0, 0, 0, 10, 3, $year);
    			$days["Reformationstag"] 				= mktime(0, 0, 0, 10, 31, $year);
    			//$days["Allerheiligen"] 				= mktime(0, 0, 0, 11, 1, $year); 
    			$days["Bu- und Bettag"] 				= mktime(0, 0, 0, 11, 26+(7-date('w', mktime(0, 0, 0, 11, 26, $year)))-11, $year); 
    			$days["1. Weihnachtsfeiertag"] 		= mktime(0, 0, 0, 12, 25, $year);
    			$days["2. Weihnachtsfeiertag"] 		= mktime(0, 0, 0, 12, 26, $year);
    			return $days;
  			}
		}
		if(!isset($year) || empty($year)) $year = date('Y');
		$tag = new Feiertag();
		$days = $tag->getHolidays($year);

	   foreach($days as $value)
   	{
         list($key, $value) = each($days);
			//Timestamp von heute
      	$heute      = mktime (0,0,0,date("m"),date("d"),date("y"));
        	//schauen ob Termin auf heute($erg = 0) oder morgen fllt ($erg = -1)
      	$diff       = $heute-$value;
      	$erg        = $diff/((60*60)*24);

	      //Feiertag gefunden => hier speichern
   	   if ($erg == 0 or $erg == -1)
      	{
         	//nur fr den Designer
         	if ($hrs == 23 and $min == 59 or $hrs == 00 and $min == 01 or $terminmodus !=0)
         	{
					if($erg == -1)
					{
						$term_text = date("d.m. ", strtotime("+1 day"));
	      	      $term_text.= $key;
						$wf[] = $term_text;

						//WebFront & Dashboard Ausgabe
					 	sort($wf);
						$term_wf = implode("\n", $wf);
						SetValueString($id_termine, $term_wf);
					}
					else
					{
	            	$term_text = date("d.m. ");
	      	      $term_text.= $key;
						$wf[] = $term_text;

						//WebFront & Dashboard Ausgabe
					 	sort($wf);
						$term_wf = implode("\n", $wf);
						SetValueString($id_termine, $term_wf);

   	         }
         	}
      	}

      	//Feiertag fr die einzelnen Modi vorlesen

	      //Terminmodus 1
   	   if($erg == -1 and $terminmodus == 1)
      	{
         	SetValueBoolean($id_term_mod1_ansage, true);
            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
				TTS_Play(1,"Achtung Feiertag morgen  .$key","meldung",2); 
            //===> Sprachausgabe anpassen, Ende
      	}
      	//Terminmodus 2
      	if($erg == -1 and $terminmodus == 2)
      	{
         	SetValueBoolean($id_term_mod2_ansage, true);
            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
  				TTS_Play(3,"Achtung Feiertag morgen  .$key","meldung",2);
            //===> Sprachausgabe anpassen, Ende
      	}
      	//Terminmodus 3
      	if($erg == 0 and $terminmodus == 3)
      	{
         	SetValueBoolean($id_term_mod3_ansage, true);
         	sleep(1);
            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
  				TTS_Play(3,"Achtung Feiertag heute  .$key","meldung",2);
            //===> Sprachausgabe anpassen, Ende
      	}
      	//Terminmodus 4 
      	if($erg == 0 and $terminmodus == 4)
      	{
         	SetValueBoolean($id_term_mod4_ansage, true);
        		sleep(1);
            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
  				TTS_Play(1,"Achtung Feiertag heute  .$key","meldung",2);
            //===> Sprachausgabe anpassen, Ende
      	}
      	//Terminmodus 5
      	if($erg == 0 and $terminmodus == 5)
      	{
         	SetValueBoolean($id_term_mod5_ansage, true);
         	sleep(1);
            //===> Sprachausgabe nach eigenen Wnschen anpassen, Anfang
  				TTS_Play(2,"Achtung Feiertag heute  .$key","meldung",2);
            //===> Sprachausgabe anpassen, Ende
      	}

	   } //for Schleife beenden

	   //Termin Symbol Designer anzeigen, wenn Termin oder gefunden wurde
   	$termine = GetValueString($id_termine);
   	if($termine != "") SetValueBoolean($id_term, true);
   	//Terminmodus beenden
   	if($terminmodus !="0") SetValueInteger($id_terminmodus, 0);

 		return;//raus wenn durch TimerEvent oder Terminmodus 6 gestartet
 	}

	//---------------------------------------------------------------------------
 	//------------------------------ Terminverwaltung ---------------------------
 	//---------------------------------------------------------------------------

	//Datenstze laden oder ersten Datensatz erzeugen

 	if(file_exists($filename)) //Datenstze laden
 	{
   	$termfile = file_get_contents($filename); //Termine in Variable einlesen
   	$term_arr_komplett = explode("\r\n", $termfile); // nach Zeilenumbruch trennen und in array
 	}
 	else //erster Datensatz
 	{
   	$term_neu_komplett = "000000000,0,0,0,0,0,0,0,0,0,0,00,00,00,00,,0,,,0,0,0,0,0,0,,0,0"."\r\n"; // 1 x Platzhalter String erzeugen
   	$handle=fopen($filename, "w");
   	fwrite($handle,$term_neu_komplett);
   	fclose($handle);
   	SetValueInteger($id_counter,0);
   	return;
 	}

 	$counter_summe = count($term_arr_komplett); // Werte zhlen
 	SetValueInteger($id_counter_summe,$counter_summe-1); //Gesamtsumme der Datenstze

 	//--------------------------- Datensatz vor ---------------------------------

 	if($IPS_COMPONENT == "vor" or $IPS_COMPONENT == "vor_10")
 	{
   	SetValueString($id_term_meldung,"");
   	if($IPS_COMPONENT == "vor")
   	{
      	$counter = GetValueInteger($id_counter);
      	$counter = $counter+1;
      	$werte = count($term_arr_komplett); // Werte zhlen
      	if($counter >= $werte){$counter=1;} //Am Ende Zhler auf Anfang
      	SetValueInteger($id_counter, $counter);
      	$term_arr = explode(",", $term_arr_komplett[$counter]);
   	}
   	if($IPS_COMPONENT == "vor_10")
   	{
      	$counter = GetValueInteger($id_counter);
      	$counter = $counter+10;
      	if($counter_summe-1 < $counter){return;} // raus wenn Datensatz nicht existiert
      	$werte = count($term_arr_komplett); // Werte zhlen
      	if($counter == $werte){$counter=$werte-1;}
      	SetValueInteger($id_counter, $counter);
      	$term_arr = explode(",", $term_arr_komplett[$counter]);
   	}
   	term_anz();
   	return;
 	}

 	//---------------------------- Datensatz zurck -----------------------------

 	if($IPS_COMPONENT == "zur" or $IPS_COMPONENT == "zur_10")
 	{
   	SetValueString($id_term_meldung,"");
   	if($IPS_COMPONENT == "zur")
   	{
      	$counter = GetValueInteger($id_counter);
      	$counter = $counter-1;
      	$werte = count($term_arr_komplett); // Werte zhlen
      	if($counter<1){$counter=$werte-1;}
      	SetValueInteger($id_counter, $counter);
      	$term_arr = explode(",", $term_arr_komplett[$counter]);
   	}
   	if($IPS_COMPONENT == "zur_10")
   	{
      	$counter = GetValueInteger($id_counter);
      	$counter = $counter-10;
      	if($counter<1){$counter=1;}
      	SetValueInteger($id_counter, $counter);
      	$term_arr = explode(",", $term_arr_komplett[$counter]);
   	}
   	term_anz();
   	return;
 	}

	//--------------------------- neuer Datensatz -------------------------------

 	if($IPS_COMPONENT == "neu")
 	{
		//Counter auf neuen Datensatz setzen
		SetValueInteger($id_counter, count($term_arr_komplett)); // Werte zhlen

	   //leerer Datensatz und aktiv gesetzt
   	$string = array
   	(
   	$id_term_stunde,
   	$id_term_minute,
  		$id_term_tag,
  		$id_term_monat,
	  	$id_term_trigger,
	  	$id_term_trigger_para
   	);

   	foreach($string as $value) SetValueString($value, "0");

   	$bool = array
   	(
   	$id_term_einmalig,
   	$id_term_jaerlich,
   	$id_term_mo,
   	$id_term_di,
   	$id_term_mi,
   	$id_term_do,
   	$id_term_fr,
   	$id_term_sa,
   	$id_term_so,
   	$id_term_14tag_ger,
   	$id_term_14tag_ung,
   	$id_term_loe
   	);

	   foreach($bool as $value) SetValueBoolean($value, false);

   	$integer = array
   	(
   	$id_term_erin,
   	$id_term_art
		);

	   foreach($integer as $value) SetValueInteger($value, 0);

   	SetValueBoolean($id_term_aktiv, true);

   	SetValueString($id_term_inhalt, "");

   	SetValueString($id_term_meldung,"Bitte neuen Datensatz eingeben");
 	}

 	//----------------------------- Datensatz lschen ---------------------------

 	if($IPS_COMPONENT == "loe")
 	{
   	$counter = GetValueInteger($id_counter);
   	unset ($term_arr_komplett[$counter]);
   	$term_neu_komplett = implode("\r\n", $term_arr_komplett); // in String zurck
   	$handle=fopen($filename, "w");
   	fwrite($handle,$term_neu_komplett);
   	fclose($handle);

   	$counter = $counter-1;
   	if($counter<1){$counter=1;}
   	SetValueInteger($id_counter, $counter);
		$termfile = file_get_contents($filename); //Termine in Variable einlesen
   	$term_arr_komplett = explode("\r\n", $termfile); // nach Zeilenumbruch trennen und in array
		$term_arr = explode(",", $term_arr_komplett[$counter]);

	   //vorherigen Datensatz anzeigen
   	term_anz();

	   $counter_summe = count($term_arr_komplett); // Werte zhlen
   	SetValueInteger($id_counter_summe,$counter_summe-1); //Gesatmsumme der Datenstze

	   SetValueString($id_term_meldung,"Datensatz gelscht");
   	SetValueInteger($id_terminmodus, 6);
  	 	IPS_RunScript($IPS_SELF);
   	return;
 	}

	//----------------------------- Datensatz speichern -------------------------

 	if($IPS_COMPONENT == "speichern")
 	{
   	$counter       = GetValueInteger($id_counter);

		$term_arr[0] = ""; //Timestamp auf Index 0 setzen und an den Anfang des array

	   term_hol();

		//Datensatz prfen===>

	   //wenn Stundenwert >24 Uhr oder kleiner 0 Uhr
   	if((int)$term_stunde > 24 or (int)$term_stunde < 0 or (int)$term_minute >59 or (int)$term_minute < 0)
   	{
      	SetValueString($id_term_meldung,"Diese Uhrzeit ist nicht mglich.");
        	return;
   	}

	   //wenn Stundenwert 24 Uhr und min grer 0
   	if((int)$term_stunde == 24 and (int)$term_minute >0)
   	{
      	SetValueString($id_term_meldung,"Diese Uhrzeit ist nicht mglich.");
      	return;
   	}

		//nach Buchstaben und Sonderzeichen suchen
		if(preg_match("/[^0-9]/", $term_arr[11]) or preg_match("/[^0-9]/", $term_arr[12]) or
			preg_match("/[^0-9]/", $term_arr[13]) or preg_match("/[^0-9]/", $term_arr[11]))
		{
        	SetValueString($id_term_meldung,"Datum oder Uhrzeit haben ein falsches Format.");
        	return;
		}
		else
		{
	   	//Zeitstempel aus Datensatz generieren
   		$term_arr[0] = mktime((int)$term_stunde, (int)$term_minute, 0, (int)$term_monat, (int)$term_tag, 2000);
   	}

	   //wenn jhrlich, einmalig, wchentlich der monatlich nicht gesetzt sind
   	if(
   	!$term_jaerlich and !$term_einmalig and !$term_monatlich and !$term_mo	and !$term_di and
   	!$term_mi		 and !$term_do 		and !$term_fr  and !$term_sa and !$term_so)
   	{
      	SetValueString($id_term_meldung,"Wiederholungswert wurde nicht eingegeben.");
      	return;
   	}

	   //wenn jhrlich und einmalig gesetzt
   	if($term_jaerlich and $term_einmalig or $term_jaerlich and $term_monatlich or
			$term_einmalig and $term_monatlich)
   	{
      	SetValueString($id_term_meldung,"Wiederholungswerte passen nicht zueinander.");
      	return;
   	}

		//wenn nicht einmalig gesetzt und Termin lschen gesetzt
   	if(!$term_einmalig and $term_loe)
   	{
      	SetValueString($id_term_meldung,"...danach lschen ist nur in Verbindung mit einem einmaliger Wiederholung ist nicht mglich.");
      	return;
   	}
   	
	   //wenn jhrlicher oder einmaliger Termin und Monat >12 oder <1
   	if(
   	$term_jaerlich  and (int)$term_monat > 12 or
   	$term_jaerlich  and (int)$term_monat < 1 or
   	$term_einmalig  and (int)$term_monat > 12 or
   	$term_einmalig  and (int)$term_monat < 1)
   	{
      	SetValueString($id_term_meldung,"Monatswert grer 12 oder kleiner 1 nicht mglich.");
      	return;
   	}

 	   //wenn monatlicher Termin und Monat !=0
   	if($term_monatlich and (int)$term_monat != 0)
   	{
      	SetValueString($id_term_meldung,"Monatswert ungleich 0 in Verbindung mit monatlicher Wiederholung ist nicht mglich.");
      	return;
   	}

 	   //wenn monatlicher Termin und Tag <= 0
   	if($term_monatlich and (int)$term_tag <= 0)
   	{
      	SetValueString($id_term_meldung,"Tageswert kleiner und gleich 0 in Verbindung mit monatlicher Wiederholung ist nicht mglich.");
      	return;
   	}

		//wenn monatlicher Termin => Tage prfen
   	if($term_monatlich and (int)$term_tag > 31)
   	{
      	SetValueString($id_term_meldung,"Tageswert grer 31 ist nicht mglich.");
      	return;
   	}

	   //Anzahl der Tage im Monat errechnen
		if($term_monat>0) $mon_days = cal_days_in_month(CAL_GREGORIAN,(int)$term_monat,date("Y"));

	   //dieses Datum ist nicht mglich
   	if(
   	$term_jaerlich and (int)$term_tag > $mon_days or $term_einmalig and (int)$term_tag > $mon_days)
   	{
      	SetValueString($id_term_meldung,"Dieses Datum ist in ".date("Y")." nicht mglich.");
      	return;
   	}

   	//wenn Wochenwert gesetzt und jhrlich gesetzt
   	if(
   	$term_jaerlich and $term_mo or
   	$term_jaerlich and $term_di or
   	$term_jaerlich and $term_mi or
   	$term_jaerlich and $term_do or
   	$term_jaerlich and $term_fr or
   	$term_jaerlich and $term_sa or
   	$term_jaerlich and $term_so)
   	{
      	SetValueString($id_term_meldung,"Wchentliche Wiederholung in Verbindung mit Jhrlich ist nicht mglich.");
      	return;
   	}

   	//wenn Wochenwert gesetzt und jhrlich gesetzt
   	if(
   	$term_monatlich and $term_mo or
   	$term_monatlich and $term_di or
   	$term_monatlich and $term_mi or
   	$term_monatlich and $term_do or
   	$term_monatlich and $term_fr or
   	$term_monatlich and $term_sa or
   	$term_monatlich and $term_so)
   	{
      	SetValueString($id_term_meldung,"Wchentliche Wiederholung in Verbindung mit Monatlich ist nicht mglich.");
      	return;
   	}

	   //wenn Wochenwert gesetzt und einmalig gesetzt
   	if(
   	$term_einmalig and $term_mo or
   	$term_einmalig and $term_di or
   	$term_einmalig and $term_mi or
   	$term_einmalig and $term_do or
   	$term_einmalig and $term_fr or
   	$term_einmalig and $term_sa or
   	$term_einmalig and $term_so)
   	{
      	SetValueString($id_term_meldung,"Wchentliche Wiederholung in Verbindung mit Einmalig ist nicht mglich.");
      	return;
   	}

	   //wenn Wochenwert gesetzt und Datum != 0
   	if(
   	$term_tag   != 0 and $term_mo or
   	$term_tag   != 0 and $term_di or
   	$term_tag   != 0 and $term_mi or
   	$term_tag   != 0 and $term_do or
   	$term_tag   != 0 and $term_fr or
   	$term_tag   != 0 and $term_sa or
   	$term_tag   != 0 and $term_so or
   	$term_monat != 0 and $term_mo or
   	$term_monat != 0 and $term_di or
   	$term_monat != 0 and $term_mi or
   	$term_monat != 0 and $term_do or
   	$term_monat != 0 and $term_fr or
   	$term_monat != 0 and $term_sa or
   	$term_monat != 0 and $term_so)
   	{
      	SetValueString($id_term_meldung,"Wchentliche Wiederholung in Verbindung mit einem Datum ist nicht mglich.");
      	return;
   	}

	   //wenn termin weniger als 2 Zeichen
   	if(strlen($term_inhalt)<2)
   	{
      	SetValueString($id_term_meldung,"Dieser Termineintrag ist zu kurz oder wurde nicht mit Enter besttigt.");
      	return;
   	}
      //wenn termin Komma enthlt
   	if(preg_match("/,/",$term_inhalt))
   	{
      	SetValueString($id_term_meldung,"Ein Komma im Termineintrag ist nicht mglich.");
      	return;
   	}
   	
	   //wenn Wochenwert gesetzt, Datum auf 0 setzen
   	if($term_mo or	$term_di or $term_mi or	$term_do or	$term_fr or	$term_sa or	$term_so)
   	{
      	$term_arr[13] = "00";
      	$term_arr[14] = "00";
   	}

	   //wenn jhrlich gesetzt, Zeit auf 0 setzen
   	if($term_jaerlich)
   	{
      	$term_arr[11] = "00";
      	$term_arr[12] = "00";
   	}

		//Formatierung
  		if($term_arr[1] == "") 		$term_arr[1] ="0";
		if($term_arr[2] == "") 		$term_arr[2] ="0";
		if($term_arr[3] == "") 		$term_arr[3] ="0";
		if($term_arr[4] == "") 		$term_arr[4] ="0";
		if($term_arr[5] == "") 		$term_arr[5] ="0";
		if($term_arr[6] == "") 		$term_arr[6] ="0";
		if($term_arr[7] == "") 		$term_arr[7] ="0";
		if($term_arr[8] == "") 		$term_arr[8] ="0";
		if($term_arr[9] == "") 		$term_arr[9] ="0";
		if($term_arr[10] == "") 	$term_arr[10] ="0";
		if($term_arr[11] == "0") 	$term_arr[11] ="00";
		if($term_arr[12] == "0") 	$term_arr[12] ="00";
		if($term_arr[16] == "") 	$term_arr[16] ="0";
		if($term_arr[19] == "") 	$term_arr[19] ="0";
		if($term_arr[20] == "") 	$term_arr[20] ="0";
		if($term_arr[22] == "") 	$term_arr[22] ="0";
		if($term_arr[24] == "") 	$term_arr[24] ="0";

	   $term_neu = implode(",", $term_arr); // in String zurck

  	 	$term_arr_komplett[$counter] = $term_neu;
   	sort($term_arr_komplett); // nach Zeit sortieren
   	$term_neu_komplett = implode("\r\n", $term_arr_komplett); // in String zurck
   	$handle=fopen($filename, "w");
   	fwrite($handle,$term_neu_komplett);
   	fclose($handle);

	   SetValueString($id_term_meldung,"Datensatz gespeichert");

   	$term_arr = explode(",", $term_arr_komplett[$counter]);
   	term_anz();

   	SetValueBoolean($id_term, false); //Terminsymbol lschen
   	SetValueInteger($id_terminmodus, 6);
   	IPS_RunScript($IPS_SELF);
 	}

 	$counter_summe = count($term_arr_komplett); // Werte zhlen
 	SetValueInteger($id_counter_summe,$counter_summe-1); //Gesatmsumme der Datenstze

	//---------------------- Erinnerungsfenster lschen -------------------------

	if($IPS_COMPONENT == "erin")
	{
		SetValueString($id_term_erin_anzeige, "");
	 	SetValueBoolean($id_term_erin_vis, false);
	}

	//----------------------- Liste Terminart anzeigen --------------------------

 	if($IPS_VARIABLE == $id_term_art_liste)
 	{
		$termfile 				= file_get_contents($filename); //Termine in Variable einlesen
   	$term_arr_komplett 	= explode("\r\n", $termfile); // nach Zeilenumbruch trennen und in array
		$summe 					= count($term_arr_komplett);
      $term_neu 				= array();
      
		for($i=0; $i<$summe; $i++)
		{
			$term_arr = explode(",", $term_arr_komplett[$i]); // einzelnen Datensatz in Daten zerlegen
			if($term_arr[23] == GetValueInteger($id_term_art_liste))
			{
			   //Einmaliger Termin
				if($term_arr[1] == 1) 
				{
					$term_ausg	= "[Einmalig] ,$term_arr[0], $term_arr[13].$term_arr[14], $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
            //wchentlicher Termin am Montag
				if($term_arr[3] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 1;
					$term_ausg  = "[Wchentlich] $txt,$term_arr[0], Montag, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
            //wchentlicher Termin am Dienstag
				if($term_arr[4] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 2;
					$term_ausg = "[Wchentlich] $txt,$term_arr[0], Dienstag, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
            //wchentlicher Termin am Mittwoch
				if($term_arr[5] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 3;
					$term_ausg  = "[Wchentlich] $txt,$term_arr[0], Mittwoch, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
            //wchentlicher Termin am Donnerstag
				if($term_arr[6] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 4;
					$term_ausg  = "[Wchentlich] $txt,$term_arr[0], Donnerstag, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
            //wchentlicher Termin am Freitag
				if($term_arr[7] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 5;
					$term_ausg  = "[Wchentlich] $txt,$term_arr[0], Freitag, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
            //wchentlicher Termin am Samstag
				if($term_arr[8] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 6;
					$term_ausg  = "[Wchentlich] $txt,$term_arr[0], Samstag, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
				//wchentlicher Termin am Sonntag
				if($term_arr[9] == 1)
				{
				   $txt = "";
               if($term_arr[19] == 1) $txt = "[jede gerade Woche]";
               if($term_arr[20] == 1) $txt = "[jede ungerade Woche]";
               $term_arr[0] = 7;
					$term_ausg  = "[Wchentlich] $txt,$term_arr[0], Sonntag, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
			   //Monatlicher Termin
				if($term_arr[24] == 1)
				{
					$term_ausg  = "[Monatlich] ,$term_arr[0], $term_arr[13]. Tag des Monats, $term_arr[11].$term_arr[12] Uhr, $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
		   	//Jhrlicher Termin
				if($term_arr[2] == 1)
				{
					$term_ausg  = "[Jhrlich] ,$term_arr[0], $term_arr[13].$term_arr[14], $term_arr[25]";
					$term_neu[] = $term_ausg; // in String zurck
				}
			}
		}
		$z = count($term_neu);
		if($z>0)
		{
			sort($term_neu); // nach Zeit sortieren
			$summe = count($term_neu);
      	for($i=0; $i<$summe; $i++)
			{
				$term_arr = explode(",", $term_neu[$i]); // einzelnen Datensatz in Daten zerlegen
				unset($term_arr[1]);
	      	$term_liste[] = implode(",", $term_arr); // in String zurck
			}
		}
		else
		{
			$term_liste 	= array();
			$term_liste[1] = "Kein Datensatz gefunden.";
	   }
		$term_neu_komplett = implode("\r\n", $term_liste); // in String zurck
		SetValueString($id_term_art_liste_text, $term_neu_komplett); //Listenstring zur Anzeige im Dash

		SetValueInteger($id_tab_index, 8); //Listenseite Dash anzeigen
 		return;
	}

 	//------------------------------- Funktionen --------------------------------

 	function term_anz() //Datensatz anzeigen
 	{
   	global $term_arr;

	   global $id_term_einmalig, $id_term_jaerlich, $id_term_mo, $id_term_di, $id_term_mi;
   	global $id_term_do, $id_term_fr, $id_term_sa, $id_term_so, $id_term_aktiv, $id_term_stunde;
   	global $id_term_minute, $id_term_tag, $id_term_monat, $id_term_inhalt, $id_term_loe;
		global $id_term_trigger, $id_term_trigger_para, $id_term_14tag_ger, $id_term_14tag_ung, $id_term_arr;
		global $id_term_erin, $id_term_anzei, $id_term_art, $id_term_monatlich;

		SetValueBoolean($id_term_einmalig, (bool)$term_arr[1]);
   	SetValueBoolean($id_term_jaerlich, (bool)$term_arr[2]);
   	SetValueBoolean($id_term_mo,       (bool)$term_arr[3]);
   	SetValueBoolean($id_term_di,       (bool)$term_arr[4]);
   	SetValueBoolean($id_term_mi,       (bool)$term_arr[5]);
   	SetValueBoolean($id_term_do,       (bool)$term_arr[6]);
   	SetValueBoolean($id_term_fr,       (bool)$term_arr[7]);
   	SetValueBoolean($id_term_sa,       (bool)$term_arr[8]);
   	SetValueBoolean($id_term_so,       (bool)$term_arr[9]);
   	SetValueBoolean($id_term_aktiv,    (bool)$term_arr[10]);
   	SetValueString($id_term_stunde,   		  $term_arr[11]);
   	SetValueString($id_term_minute,   		  $term_arr[12]);
   	SetValueString($id_term_tag,      		  $term_arr[13]);
   	SetValueString($id_term_monat,    		  $term_arr[14]);
   	SetValueBoolean($id_term_loe, 	  (bool)$term_arr[16]);
   	SetValueBoolean($id_term_14tag_ger,(bool)$term_arr[19]);
   	SetValueBoolean($id_term_14tag_ung,(bool)$term_arr[20]);
      SetValueInteger($id_term_erin,	   (int)$term_arr[21]);
      SetValueBoolean($id_term_anzei,	  (bool)$term_arr[22]);
      SetValueInteger($id_term_art,			(int)$term_arr[23]);
      SetValueBoolean($id_term_monatlich,(bool)$term_arr[24]);
     	SetValueString($id_term_inhalt,   		  $term_arr[25]);
    	SetValueString($id_term_trigger,         $term_arr[26]);
	 	SetValueString($id_term_trigger_para,    $term_arr[27]);
 	}

	function term_hol() //Datensatz holen
 	{
   	global $term_arr, $term_einmalig, $term_jaerlich, $term_mo, $term_di, $term_mi;
   	global $term_do, $term_fr, $term_sa, $term_so, $term_aktiv, $term_stunde;
   	global $term_minute, $term_tag, $term_monat, $term_inhalt, $term_loe;
		global $term_trigger, $term_trigger_para, $term_14tag_ger, $term_14tag_ung, $term_arr;
		global $term_erin, $term_anzei, $term_art, $term_monatlich;

	   global $id_term_arr, $id_term_einmalig, $id_term_jaerlich, $id_term_mo, $id_term_di, $id_term_mi;
   	global $id_term_do, $id_term_fr, $id_term_sa, $id_term_so, $id_term_aktiv, $id_term_stunde;
   	global $id_term_minute, $id_term_tag, $id_term_monat, $id_term_inhalt, $id_term_loe;
		global $id_term_trigger, $id_term_trigger_para, $id_term_14tag_ger, $id_term_14tag_ung, $id_term_arr;
		global $id_term_erin, $id_term_anzei, $id_term_art, $id_term_monatlich;
		
		$term_einmalig 		= $term_arr[1]  = GetValueBoolean($id_term_einmalig);
   	$term_jaerlich 		= $term_arr[2]  = GetValueBoolean($id_term_jaerlich);
   	$term_mo       		= $term_arr[3]  = GetValueBoolean($id_term_mo);
   	$term_di       		= $term_arr[4]  = GetValueBoolean($id_term_di);
   	$term_mi       		= $term_arr[5]  = GetValueBoolean($id_term_mi);
   	$term_do       		= $term_arr[6]  = GetValueBoolean($id_term_do);
   	$term_fr       		= $term_arr[7]  = GetValueBoolean($id_term_fr);
   	$term_sa       		= $term_arr[8]  = GetValueBoolean($id_term_sa);
   	$term_so       		= $term_arr[9]  = GetValueBoolean($id_term_so);
   	$term_aktiv    		= $term_arr[10] = GetValueBoolean($id_term_aktiv);
  		$term_stunde 			= $term_arr[11] = sprintf("%02s", GetValueString($id_term_stunde));
      $term_minute 			= $term_arr[12] = sprintf("%02s", GetValueString($id_term_minute));
  		$term_tag	 			= $term_arr[13] = sprintf("%02s", GetValueString($id_term_tag));
      $term_monat  			= $term_arr[14] = sprintf("%02s", GetValueString($id_term_monat));
  		                       $term_arr[15] = "";
   	$term_loe      		= $term_arr[16] = GetValueBoolean($id_term_loe);
		                       $term_arr[17] = "";
  		                       $term_arr[18] = "";
     	$term_14tag_ger	 	= $term_arr[19] = GetValueBoolean($id_term_14tag_ger);
     	$term_14tag_ung	 	= $term_arr[20] = GetValueBoolean($id_term_14tag_ung);
     	$term_erin			 	= $term_arr[21] = GetValueInteger($id_term_erin);
     	$term_anzei			 	= $term_arr[22] = GetValueBoolean($id_term_anzei);
     	$term_art			 	= $term_arr[23] = GetValueInteger($id_term_art);
     	$term_monatlich   	= $term_arr[24] = GetValueBoolean($id_term_monatlich);
   	$term_inhalt   		= $term_arr[25] = GetValueString($id_term_inhalt);
     	$term_trigger      	= $term_arr[26] = GetValueString($id_term_trigger);
	  	$term_trigger_para  	= $term_arr[27] = GetValueString($id_term_trigger_para);
 	}

 	//---------------------------------------------------------------------------

?>
