<?

$FHZ_ID = IPS_GetObjectIDByName("FHZ1X00PC", 0); //ID des FHZ1300 Moduls
$Sende_Interval_Ventilpos=115;
$Signal_vor_Sendezeit=11;
$FHT_Liste=FHTCreateList();

// Zhler fr FHTs, die bereits synchronisiert wurden
$count = CreateVariableByName($IPS_SELF, "Count", 1);
echo "FHT: ".(GetValue($count)+1)." von ".sizeof($FHT_Liste)."\n";


//FHT mit dem ltesten Update suchen
$aeltester_Wert=9999999999999;
$weitersuchen=TRUE;
foreach($FHT_Liste as $FHT_Daten)
    {
    $v=IPS_GetVariable($FHT_Daten['1']);
    $letztes_Update=$v['VariableUpdated'];
    if((($letztes_Update<$aeltester_Wert) OR (GetValue($FHT_Daten['1'])<>"gesendet")) AND $weitersuchen==TRUE)
       {
        $aeltester_Wert=$letztes_Update;
        if(GetValue($FHT_Daten['1'])<>"gesendet") $weitersuchen=FALSE; //Falls diese FHT bereits in bearbeitung ist, nicht weitersuchen
        $FHT_ID=$FHT_Daten['0'];
        $FHT_Variable=$FHT_Daten['1'];
        $FHT_Ventil_Variable=$FHT_Daten['2'];
        }
    }

echo $FHT_ID." \n".$FHT_Variable." \n".$FHT_Ventil_Variable." \n".$weitersuchen." \n";


//Stunde wurde gesendet - Jetzt prfen
if(substr((GetValue($FHT_Variable)),0,12)=="sende Stunde")
    {
    $result = Stunde_pruefen($FHT_ID, $FHT_Variable, $IPS_SELF, $FHZ_ID);
    if ($result)                 // Wenn Stunde erfolgreich nertragen, Timer setzten fr nchste FHT
    {
       if (GetValue($count) < sizeof($FHT_Liste)-1)
       {
            IPS_SetScriptTimer($IPS_SELF, 10);
            SetValue($count, GetValue($count) + 1);
        } else                     //Wenn alle FHT synchronisiert wurde, Timer ausschlten
            {
               SetValue($count, 0);
                IPS_SetScriptTimer($IPS_SELF, 0);
                echo "Alle FHTs synchronisiert\n";
            }
    }
    return;
    }


//Uhrzeit prfen - zum Stundenwechsel knnte es zur Verschiebung kommen
if(date('i')>50)
    {
    echo "ungnstige Zeit (Stundenwechsel) - warten...";
    IPS_SetScriptTimer ($IPS_SELF,300);
    return;
    }
if(date('i')<5)
    {
    echo "ungnstige Zeit (Stundenwechsel) - warten...";
    IPS_SetScriptTimer ($IPS_SELF,120);
    return;
    }


//Buffer der FHZ prfen - freier Buffer ist zur Empfangskontrolle erforderlich
$Freie_Buffer=FHZ_GetFreeBuffer($FHZ_ID);
if($Freie_Buffer<10)
    {
    echo "Buffer belegt... 2 Minuten warten";
   IPS_SetScriptTimer ($IPS_SELF,120); //nchster Versuch in 2 Minuten (auf Buffer warten)
    return;
    }

//------------------   Was soll getan werden?   --------------------
//Minute wurde gesendet - Jetzt Stunde senden
if(GetValue($FHT_Variable)=="Minute gesendet")
    {
    Stunde_senden($FHT_ID, $FHT_Variable, $IPS_SELF);
    return;
    }


//----------------- Minute senden  ----------------------------------
//letzten und nchsten Timeport / Sendeplatz ermitteln
$v=IPS_GetVariable($FHT_Ventil_Variable);
$letzter_Timeport_Zeit=$v['VariableUpdated'];
$letzter_Timeport=intval(time()-$letzter_Timeport_Zeit);
echo "letzter Empfang: ".$letzter_Timeport." s \n";
if($letzter_Timeport>$Sende_Interval_Ventilpos)
    {
    echo "letzte Ventilposition nicht empfangen - nchster Versuch in 1,5 Minuten!";
   IPS_SetScriptTimer ($IPS_SELF,90); //nchster Versuch in 2 Minuten (Warte auf Empfang der Ventilposition)
    return;
    }
$Empfang_in=$Sende_Interval_Ventilpos-$letzter_Timeport;
echo "nchster Timeport: ".$Empfang_in." s \n";
$Sende_in=$Empfang_in-$Signal_vor_Sendezeit;
if ($Sende_in < -1)  //Sendeplatz berspringen (Signal_vor_Sendzeit um mehr als eine Sekunde unterschritten)
    {
    $Sende_in=$Sende_in+$Sende_Interval_Ventilpos;
    }
echo "Sende in ".$Sende_in." s \n";


//Signal senden oder Script beim nchsten Timeport neu starten
if ($Sende_in < 13) //Timeport getroffen - Signal senden
    {
    echo "Timeport getroffen - jetzt senden! \n ";
   IPS_SetScriptTimer ($IPS_SELF, 0);
    $sende_Minute=date('i',time()+$Empfang_in); //aktuelle Minute zum voraussichtlichen Zeitpunkt des Empfangs
    SetValue($FHT_Variable,"sende m=".$sende_Minute);
   FHT_SetMinute($FHT_ID,intval($sende_Minute));
   IPS_SetScriptTimer ($IPS_SELF,0);  //zunchst lschen um neuen Programmstart whrend Empfangstest zu vermeiden
    $Empfangstest=TRUE; //nchsten Programmteil starten
    }
    ELSE //warten auf nchsten Timeport
    {
    echo "Setze Script-Timer auf ".$Sende_in." s \n";
    IPS_SetScriptTimer ($IPS_SELF, $Sende_in);
    SetValue($FHT_Variable,"sende in ".$Sende_in."s");
   $Empfangstest=FALSE; //nchsten Programmteil nicht starten
    }
//------------------------------ Empfangstest fr Minutensignal ------------------------------
if ($Empfangstest==TRUE)
    {
    IPS_Sleep(1000); //warten bis Signal im Buffer ist
    $Durchlauf=0;
    while((FHZ_GetFreeBuffer($FHZ_ID)<10) AND ($Durchlauf<20))
       {
        $Durchlauf=$Durchlauf+1;
        //echo "Buffer geprft - Signal wartet \n";
        IPS_Sleep(1000);
        }
    if(FHZ_GetFreeBuffer($FHZ_ID)==10)
       {
        echo "Signal wurde nach ".$Durchlauf." Sekunden abgerufen! \n";
        SetValue($FHT_Variable,"Minute gesendet");
      IPS_SetScriptTimer ($IPS_SELF,60);  //erneut starten um bertragung der Stunde zu starten
        }
        ELSE //Signal wurde nicht abgerufen
        {
      echo "Fehler - Signal wurde nach 20 Sek nicht abgerufen! \n";
        SetValue($FHT_Variable,"Fehler!");
      IPS_SetScriptTimer ($IPS_SELF,120); //nchster Versuch in 2 Minuten (neues Signal senden)
        }
    }


//---------------------------- ab hier Definition der Funktionen zur Stundenbertragung -------------

function Stunde_senden($FHT_ID, $FHT_Variable, $IPS_SELF)
    {
    $akt_Stunde=date('H');
    SetValue($FHT_Variable,"sende Stunde ".$akt_Stunde);
    echo "Sende Stunde ".$akt_Stunde." \n";
    FHT_SetHour($FHT_ID,intval($akt_Stunde));
    IPS_SetScriptTimer ($IPS_SELF,60);  //erneut starten um Empfang der Stunde zu prfen
    }

function Stunde_pruefen($FHT_ID, $FHT_Variable, $IPS_SELF, $FHZ_ID)
    {
    if(FHZ_GetFreeBuffer($FHZ_ID)<10) //Signal wurde noch nicht empfangen
       {
        echo "Stunde wurde noch nicht abgerufen - warte weiter \n";
      echo "gesendete Stunde: ".substr(GetValue($FHT_Variable),-2)."\n";
        echo "aktuelle Stunde: ".intval(date('H'))."\n";
        IPS_SetScriptTimer ($IPS_SELF,60); //in einer Minute erneut prfen
        return;
        }
    ELSE //Stunden-Signal wurde abgerufen
        {
        //Wurde die Stunde rechzeitig abgerufen (Stundenwechsel)?
        if(substr(GetValue($FHT_Variable),-2)==intval(date('H')))
            {
            echo "akutelle Stunde wurde erfolgreich bertragen! \n Script-Timer wird gelscht. \n";
         echo "bertragene Stunde: ".substr(GetValue($FHT_Variable),-2)."\n";
            echo "aktuelle Stunde: ".intval(date('H'))."\n";
            IPS_SetScriptTimer ($IPS_SELF,0);  //Vorgang beendet - Script-Timer lschen
          SetValue($FHT_Variable,"gesendet");
          return true;
            }
        ELSE
           {
         echo "Stunde wurde zu spt bertragen! \n neuer Versuch! \n";
         echo "bertragene Stunde: ".substr(GetValue($FHT_Variable),-2)."\n";
            echo "aktuelle Stunde: ".intval(date('H'))."\n";
            IPS_SetScriptTimer ($IPS_SELF,60);
          SetValue($FHT_Variable,"Minute gesendet");
          return false;
            }
        }

    }



function FHTCreateList()
{
$guid = '{A89F8DFA-A439-4BF1-B7CB-43D047208DDD}';  //FHT GUID
$ids = IPS_GetInstanceListByModuleID($guid);
 foreach($ids as $id)
 {
 //FHT-Daten in Array ablegen: FHT-ID, FHT-Zeitabgleich-Variable, FHT-Ventil-Variable
   $FHT_Liste[]=array($id, CreateVariableByName($id, "TimeSync", 3), IPS_GetStatusVariableID($id, "PositionVar"));
  }
  return $FHT_Liste;
}


function CreateVariableByName($id, $name, $type)
{
    global $IPS_SELF;
    $vid = @IPS_GetVariableIDByName($name, $id);
    if($vid === false)
    {
        $vid = IPS_CreateVariable($type);
        IPS_SetParent($vid, $id);
        IPS_SetName($vid, $name);
        IPS_SetInfo($vid, "this variable was created by script #$IPS_SELF");
        IPS_SetHidden($vid, true);
    }
    return $vid;
}

?>