<?
$host   = "192.168.0.97";       //IP des Gerte das per SNMP ausgelesen werden soll
$community  = "public";          // Lesekennwort
$dummy_name = "Drucker Status";     // Name der Dummy-Instanz
$intervall  = 60;                   // Anfrageintervall in Minuten
//Ab hier nichts mehr ndern
$object = IPS_GetObject($IPS_SELF);
$parentID = $object['ParentID'];
//Installer
if ($IPS_SENDER == "Execute")
{
    IPS_SetHidden($IPS_SELF, true);
    IPS_SetName($IPS_SELF, "Auslese-Skript");
    $parentObject = IPS_GetObject($parentID);
    if ($parentObject['ObjectType'] !== 1)
    {
        $instanceID = IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}");
        IPS_SetParent($instanceID, $parentID);
        $parentID = $instanceID;
        IPS_SetParent($IPS_SELF, $parentID);
        IPS_SetName($instanceID, $dummy_name);
        IPS_SetIcon($instanceID, "Gauge");
    }
    IPS_SetScriptTimer($IPS_SELF, $intervall*60); // Anfrageintervall
    if(!IPS_VariableProfileExists(".TonerLevel")) {
       IPS_CreateVariableProfile(".TonerLevel", 1);
       IPS_SetVariableProfileText(".TonerLevel", "", " %");
       IPS_SetVariableProfileDigits(".TonerLevel", 0);
       IPS_SetVariableProfileIcon(".TonerLevel",  "Battery");
    }
    if(!IPS_VariableProfileExists(".PagesCount")) {
       IPS_CreateVariableProfile(".PagesCount", 1);
       IPS_SetVariableProfileText(".PagesCount", "", " Seiten");
       IPS_SetVariableProfileDigits(".PagesCount", 0);
       IPS_SetVariableProfileIcon(".PagesCount",  "Information");
    }
}

$ping = Sys_Ping($host, 1000);
If ($ping <> 1) return;
$vidblack  = CreateVariableByName($parentID, "Schwarz",   1, 1, ".TonerLevel");
$vidpagesd  = CreateVariableByName($parentID, "Seitenanzahl Drucken",  1, 2, ".PagesCount");
$vidpagesk  = CreateVariableByName($parentID, "Seitenanzahl Kopie",  1, 3, ".PagesCount");
$vidpagesf  = CreateVariableByName($parentID, "Seitenanzahl Fax",  1, 4, ".PagesCount");
//$data = snmpget("$host", "$community", ".1.3.6.1.4.1.2435.2.3.9.4.2.1.5.5.52.21.1.3.1"); //Tinte schwarz
//$data = intval(str_replace("INTEGER: ", "", $data));
//SetValueInteger($vidblack, $data);

$data = snmpget("$host", "$community", ".1.3.6.1.4.1.2435.2.3.9.4.2.1.5.5.52.21.1.3.1"); //Zhler Drucker
$data = intval(str_replace("Counter32: ", "", $data));
SetValueInteger($vidpagesd, $data);

$data = snmpget("$host", "$community", ".1.3.6.1.4.1.2435.2.3.9.4.2.1.5.5.52.21.1.3.2"); //Zhler Kopie
$data = intval(str_replace("Counter32: ", "", $data));
SetValueInteger($vidpagesk, $data);

$data = snmpget("$host", "$community", ".1.3.6.1.4.1.2435.2.3.9.4.2.1.5.5.52.21.1.3.3"); //Zhler Fax
$data = intval(str_replace("Counter32: ", "", $data));
SetValueInteger($vidpagesf, $data);

function CreateVariableByName($id, $name, $type, $position, $profile="", $hidden=false)
{
    global $IPS_SELF;
    $vid = @IPS_GetVariableIDByName($name, $id);
    if($vid === false)
    {
        $vid = IPS_CreateVariable($type);
        IPS_SetParent($vid, $id);
        IPS_SetName($vid, $name);
        IPS_SetPosition($vid, $position);
        IPS_SetHidden($vid, $hidden);
        IPS_SetVariableCustomProfile($vid, $profile);
        IPS_SetInfo($vid, "this variable was created by script #$IPS_SELF");
    }
    return $vid;
}

?>