<?
//==================================================================================
// Datei.......: Graphupdate.php
// Beschreibung:  berprft welche Graph gerade erstellt werden muss
//			wird regelmig im Abstand von 60 sek aufgerufen
//
// DUG Version.....: V1.6
// SVN Revisionsnr:	$Revision: 40 $
// zuletzt gendert : 	$Date: 2009-05-29 15:53:44 +0200 (Fr, 29 Mai 2009) $
// Author:			$Author: tobias $
//==================================================================================
//graphenbasis entlt schon das include fr sqlitebasis.php
include ("DUGToolbasis.php");
include ($DUGTOOLPFAD."graphenbasis.php");


$DEBUG = false;

$dblink = dbopen();
//suche alle graphen raus, die ein Erstellungsintervall grer Null haben 
// Null bedeutet der Graph soll nicht automatisch erzeugt  werden
$select = "SELECT * FROM Graph WHERE ErstellungsIntervall != '0';";
$graphresult = sqlite_query($dblink, $select);
sqlite_close($dblink);
$i=0;
while($graphentry = sqlite_fetch_array($graphresult))
{
	if (isset($graphentry['ID']))
	{
		if ($DEBUG) {echo "check Graph: ".$graphentry['ID']."--> ".((time()+(int)$graphentry['ErstellungsOffset']) % $graphentry['ErstellungsIntervall'])."<br>";}
		if (((time()+(int)$graphentry['ErstellungsOffset']) % $graphentry['ErstellungsIntervall']) < 60)
		{
			if ($DEBUG) {echo "erstelle Graph: ".$graphentry['ID']."<br>";}
			$erstellungsliste[$i] = $graphentry['ID'];

			$i = $i+1;
		}
	}
}
//das Erstellen der Graphen ist deswegen vom  berprfen abgekoppelt, da das ERstellen mehrerer Graphen auch mal ber 60 sek 
//dauern kann. Die Graphen, die dann nach dieser Zeit berprft werden, werden dann nicht mehr als ausfhrbereit erkannt,
//obwohl sie er wren
//die Sleep Anweisung wurde eingefgt, um IPS nicht zu lange lahm zu legen
//ob ein Graph nun eine Sekunde frher oder spter erstellt wird ist wohl egal. :)
if (isset($erstellungsliste)){
	foreach($erstellungsliste as $graphID)
	{
		Graphenerstellen($graphID);
		IPS_LogMessage("DUG Tool Graphen Update", "Der Graph ".$graphID." wurde gerade neu erstellt.");
		sleep(1);
	}
}



?>