<?
	//-------------- Nur hier entsprechende nderungen eintragen !!! ------------

	//Hier Ablageort fr wecker.txt eintragen
 	$filename = IPS_GetKernelDir()."media/wecker.txt";
 	//Hier Zeit in Minuten eintragen wann Wecker nochmal melden soll
 	$schlummer_zeit = 10;

	//---------------------- Prfen ob schon installiert ------------------------

	//Array mit Informationen ber das Objekt
   $install_arr = IPS_GetObject($IPS_SELF);
	//Array mit Informationen ber das bergeordente Objekt(Parent)
	$parent_arr  = IPS_GetObject($install_arr['ParentID']);

	if($parent_arr['ObjectName'] == ".Wecker")
	{
	 	//Wecker ist bereits installiert
   }
	else
	{
		//--------------------------- Kategorie anlegen --------------------------

		$id_kat = IPS_CreateCategory();
		IPS_SetName($id_kat, ".Wecker");

		//-------------------- Script in Kategorie verschieben -------------------

	   IPS_SetParent($IPS_SELF,$id_kat);
		$objekt_id = IPS_GetObjectIDByName("wecker", $id_kat);
		if($objekt_id == 0)
		{
  			echo "Objekt nicht gefunden!";
  			return;
		}
		else
		{
      	IPS_SetParent($objekt_id, $id_kat);
		}

		//--------------------------- Variablen anlegen --------------------------

	  	//legt Variablen vom Typ Boolean an (0)
  		$var_name = array
		('schlummer_erlaubt','wecker_aktiv','wecker_feiertag','wecker_schlummer');

		$counter = count($var_name); // Werte zhlen
 		for ($x=0; $x<=$counter-1; $x++)
 		{
 			$var_id = IPS_CreateVariable(0);
   		IPS_SetName($var_id,$var_name[$x]);
   		IPS_SetParent($var_id, $id_kat);
 		}

		//legt Variablen vom Typ Integer an (1)
  		$var_name = array
		('schlummer_count','schlummer_start_zeit','wecker_name_counter',
	 	'wecker_tag_counter');

		$counter = count($var_name); // Werte zhlen
 		for ($x=0; $x<=$counter-1; $x++)
 		{
 			$var_id = IPS_CreateVariable(1);
   		IPS_SetName($var_id,$var_name[$x]);
   		IPS_SetParent($var_id, $id_kat);
 		}

		//legt Variablen vom Typ String an (3)
		$var_name = array
		('wecker_fkt','wecker_meldung','wecker_minute','wecker_name',
    	'wecker_name_neu','wecker_stunde','wecker_tag');

		$counter = count($var_name); // Werte zhlen
 		for ($x=0; $x<=$counter-1; $x++)
 		{
 			$var_id = IPS_CreateVariable(3);
   		IPS_SetName($var_id,$var_name[$x]);
   		IPS_SetParent($var_id, $id_kat);
 		}

		//------------------------- Trigger anlegen ------------------------------

		$var = 'wecker_fkt';
		$var_id = IPS_GetVariableIDByName($var, $id_kat); //ermitteln der Trigger var id
		$id = IPS_CreateEvent(0); //legt ein "Ausgelstes" Ereignis an
		IPS_SetEventTrigger($id, 0, $var_id); //bei ktualisierung von Variable mit $var_id
		IPS_SetEventScript($id, $IPS_SELF); //Trigger mit aktuellem Skript verknpfen
		IPS_SetEventActive($id, true); //Ereignis aktivieren
	}

	//---------------------- Start des Scripts ermglichen ----------------------

 	$timer_wert = IPS_GetScriptTimer($IPS_SELF);  //prfen ob Timer aktiv
	if($timer_wert != 0)
	{
  		//Timer aktiv
	}
	else
	{
  		IPS_SetScriptTimer($IPS_SELF,60); //Timer jede Minute starten
	}

	//------------------------- bentigte Variablen -----------------------------

 	$time = time();
 	$hrs = (integer)date("H", $time);
 	$min = (integer)date("i", $time);

 	$tag = (date("w")); //Tag ermitteln
 	$tag_arr = array("Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag");
 	$tag = $tag_arr[$tag]; //Tag in Bustabenform wandeln

 	$name_tag = array("Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag","Sonntag");

   $script_info = IPS_GetObject($IPS_SELF);
   $id_kat	    = $script_info['ParentID']; //Kategorie ID ermitteln

	foreach(
  	array(
    'wecker_meldung','wecker_name_counter','wecker_name','wecker_tag_counter',
    'wecker_tag','wecker_stunde','wecker_minute','wecker_feiertag',
	 'wecker_schlummer','wecker_aktiv','wecker_name_neu','wecker_fkt'
  	) as $var)
	{
  		${'id_'.$var} = IPS_GetVariableIDByName($var, $id_kat);
	}

	//---------------------------------------------------------------------------

 	if($IPS_SENDER == "Designer")
 	{
   	switch($IPS_COMPONENT)
   	{
      	//------------------------ Name eins weiter ---------------------------

      	case 'wecker_name_vor':
      	SetValue($id_wecker_meldung,"");
      	daten_laden();
      	$counter = count($wecker_datensatz); // Werte zhlen
     	 	$wecker_name_counter = GetValue($id_wecker_name_counter);
      	//letzter Wecker ereicht
      	if($wecker_name_counter == $counter-49 or $counter == 1) return;
      	$wecker_name_counter = $wecker_name_counter+49;
      	SetValue($id_wecker_name, $wecker_datensatz[$wecker_name_counter]);
      	SetValue($id_wecker_name_counter, $wecker_name_counter);
      	$wecker_tag_counter = GetValue($id_wecker_tag_counter);
      	zeit_speichern($wecker_tag_counter);
      	return;

      	//------------------------ Name eins zurck ---------------------------

      	case 'wecker_name_zur':
      	SetValue($id_wecker_meldung,"");
      	daten_laden();
      	$counter = count($wecker_datensatz); // Werte zhlen
      	$wecker_name_counter = GetValue($id_wecker_name_counter);
      	//letzter Wecker ereicht
      	if($wecker_name_counter == 0) return;
      	$wecker_name_counter = $wecker_name_counter-49;
      	SetValue($id_wecker_name, $wecker_datensatz[$wecker_name_counter]);
      	SetValue($id_wecker_name_counter, $wecker_name_counter);
      	$wecker_tag_counter = GetValue($id_wecker_tag_counter);
      	zeit_speichern($wecker_tag_counter);
      	return;

      	//---------------------------- Tag eins vor ---------------------------

      	case 'wecker_tag_vor':
      	SetValue($id_wecker_meldung,"");
      	$wecker_tag_counter = GetValueInteger($id_wecker_tag_counter);
      	$wecker_tag_counter = $wecker_tag_counter+1;
      	if($wecker_tag_counter == 7) $wecker_tag_counter = 0;
      	SetValueInteger($id_wecker_tag_counter, $wecker_tag_counter);
      	SetValueString($id_wecker_tag, $name_tag[$wecker_tag_counter]);
      	daten_laden();
      	zeit_speichern($wecker_tag_counter);
      	return;

      	//------------------------- Tag eins zurck ---------------------------

      	case 'wecker_tag_zur':
      	SetValueString($id_wecker_meldung,"");
      	$wecker_tag_counter = GetValueInteger($id_wecker_tag_counter);
      	$wecker_tag_counter = $wecker_tag_counter-1;
      	if($wecker_tag_counter < 0) $wecker_tag_counter = 6;
      	SetValue($id_wecker_tag_counter, $wecker_tag_counter);
      	SetValue($id_wecker_tag, $name_tag[$wecker_tag_counter]);
      	daten_laden();
      	zeit_speichern($wecker_tag_counter);
      	return;

	      //---------------------------- Stunde eins vor ------------------------

	      case 'wecker_stunde_hoch':
      	SetValue($id_wecker_meldung,"");
      	$wecker_stunde = GetValue($id_wecker_stunde);
      	(int)$wecker_stunde = (int)$wecker_stunde + 1;
      	if($wecker_stunde >= 24) $wecker_stunde = 0;
      	if($wecker_stunde >= 0 or $wecker_stunde <10)
      	{
         	(string)$wecker_stunde = sprintf("%02s", $wecker_stunde);
         	SetValue($id_wecker_stunde, (string)$wecker_stunde);
         	return;
      	}
      	SetValue($id_wecker_stunde, (string)$wecker_stunde);
      	return;

	      //---------------------------- Stunde eins zurck----------------------

	      case 'wecker_stunde_runter':
   	   SetValue($id_wecker_meldung,"");
      	$wecker_stunde = GetValue($id_wecker_stunde);
	      (int)$wecker_stunde = (int)$wecker_stunde - 1;
   	   if($wecker_stunde < 0) $wecker_stunde = 23;
      	if($wecker_stunde >= 0 or $wecker_stunde <10)
      	{
         	(string)$wecker_stunde = sprintf("%02s", $wecker_stunde);
         	SetValue($id_wecker_stunde, (string)$wecker_stunde);
         	return;
      	}
      	SetValue($id_wecker_stunde, (string)$wecker_stunde);
      	return;

	      //---------------------------- Minute eins vor ------------------------

	      case 'wecker_minute_hoch':
   	   SetValue($id_wecker_meldung,"");
      	$wecker_minute = GetValue($id_wecker_minute);
	      (int)$wecker_minute = (int)$wecker_minute + 1;
   	   if($wecker_minute > 59) $wecker_minute = 0;
      	if($wecker_minute >= 0 or $wecker_minute <10)
      	{
         	(string)$wecker_minute = sprintf("%02s", $wecker_minute);
         	SetValue($id_wecker_minute, (string)$wecker_minute);
         	return;
      	}
      	SetValue($id_wecker_minute, (string)$wecker_minute);
      	return;

	      //--------------------------- Minute eins zurck ----------------------

	      case 'wecker_minute_runter':
   	   SetValue($id_wecker_meldung,"");
      	$wecker_minute = GetValue($id_wecker_minute);
      	(int)$wecker_minute = (int)$wecker_minute - 1;
      	if($wecker_minute < 0) $wecker_minute = 59;
      	if($wecker_minute >= 0 or $wecker_minute <10)
      	{
         	(string)$wecker_minute = sprintf("%02s", $wecker_minute);
         	SetValue($id_wecker_minute, (string)$wecker_minute);
         	return;
      	}
      	SetValue($id_wecker_minute, (string)$wecker_minute);
      	return;

	      //----------------------------- Feiertag ------------------------------

	      case 'wecker_feiertag':
   	   SetValue($id_wecker_meldung,"");
      	$wecker_feiertag = GetValue($id_wecker_feiertag);
	      if($wecker_feiertag)
   	   {
      	   SetValue($id_wecker_feiertag, false);
      	}
      	else
      	{
         	SetValue($id_wecker_feiertag, true);
      	}
      	return;

	      //--------------------------- Schlummermodus --------------------------

	      case 'wecker_schlummer':
   	   SetValue($id_wecker_meldung,"");
	      $wecker_schlummer = GetValue($id_wecker_schlummer);
      	if($wecker_schlummer)
      	{
         	SetValue($id_wecker_schlummer, false);
      	}
      	else
      	{
         	SetValue($id_wecker_schlummer, true);
      	}
      	return;

	      //---------------------------- Wecker an/aus --------------------------

	      case 'wecker_aktiv':
   	   SetValue($id_wecker_meldung,"");
      	$wecker_aktiv = GetValue($id_wecker_aktiv);
	      if($wecker_aktiv)
    	   {
      	   SetValue($id_wecker_aktiv, false);
      	}
      	else
      	{
         	SetValue($id_wecker_aktiv, true);
      	}
      	return;

	      //-------------------------- Wecker speichern  ------------------------

	      case 'wecker_speichern':
   	   $wecker_name      = GetValue($id_wecker_name);
      	$wecker_tag       = GetValue($id_wecker_tag);
	      $wecker_stunde    = GetValue($id_wecker_stunde);
   	   $wecker_minute    = GetValue($id_wecker_minute);
      	$wecker_feiertag  = GetValue($id_wecker_feiertag);
      	$wecker_schlummer = GetValue($id_wecker_schlummer);
      	$wecker_aktiv     = GetValue($id_wecker_aktiv);

	      $i=0;
   	   daten_laden();
      	foreach($wecker_datensatz as $value)
      	{
         	if($value == $wecker_name and $wecker_tag == $wecker_datensatz[$i+1] )
         	{
            	$wecker_datensatz[$i]   = $wecker_name;
            	$wecker_datensatz[$i+1] = $wecker_tag;
            	$wecker_datensatz[$i+2] = $wecker_stunde;
            	$wecker_datensatz[$i+3] = $wecker_minute;
            	$wecker_datensatz[$i+4] = $wecker_feiertag;
            	$wecker_datensatz[$i+5] = $wecker_schlummer;
            	$wecker_datensatz[$i+6] = $wecker_aktiv;
            	daten_speichern();
            	SetValue($id_wecker_meldung,"Wecker gespeichert");
	            return;
   	      }
      	   $i=$i+1;
      	}
      	return;

	      //------------------------------ Wecker neu  --------------------------

   	   case 'wecker_neu':
	      $wecker_name_neu = GetValue($id_wecker_name_neu);
 	     	daten_laden();
      	$counter = count($wecker_datensatz); // Werte zhlen
      	$counter_merken = $counter;
      	//Namenssyntax prfen
      	if(preg_match("/[^a-zA-Z0-9]/", $wecker_name_neu))
      	{
         	SetValue($id_wecker_meldung,"Dieser Name ist nicht erlaubt!");
         	return;
      	}

      	//doppelten Namen prfen
      	foreach($wecker_datensatz as $value)
      	{
         	if($value == $wecker_name_neu)
         	{
            	SetValue($id_wecker_meldung,"Dieser Name ist schon vergeben!");
            	return;
         	}
      	}
      	//
      	if($counter < 2) // erster Datensatz
      	{
         	$counter=0;
         	$counter_merken = $counter;
      	}
      	for($tag = 0; $tag < 7; $tag++)
      	{
         	$wecker_datensatz[$counter]   = $wecker_name_neu;
         	$wecker_datensatz[$counter+1] = $name_tag[$tag];
         	$wecker_datensatz[$counter+2] = "10";
         	$wecker_datensatz[$counter+3] = "00";
         	$wecker_datensatz[$counter+4] = true;
         	$wecker_datensatz[$counter+5] = true;
         	$wecker_datensatz[$counter+6] = true;
         	$counter = $counter+7;
      	}
      	daten_speichern();
      	//neuen Wecker anzeigen
      	$counter = $counter_merken;
      	SetValue($id_wecker_meldung,$wecker_name_neu." angelegt");
      	SetValue($id_wecker_name, $wecker_datensatz[$counter]);
      	SetValue($id_wecker_tag, $wecker_datensatz[$counter+1]);
      	SetValue($id_wecker_stunde, $wecker_datensatz[$counter+2]);
      	SetValue($id_wecker_minute, $wecker_datensatz[$counter+3]);
      	SetValue($id_wecker_feiertag, $wecker_datensatz[$counter+4]);
      	SetValue($id_wecker_schlummer, $wecker_datensatz[$counter+5]);
      	SetValue($id_wecker_aktiv, $wecker_datensatz[$counter+6]);
      	SetValue($id_wecker_name_counter, $counter);
      	//Script anlegen, registrieren und der Kategorie zuordnen
      	//Wecker Script
      	$script_inhalt ="<?"."\n";
      	$script_inhalt.="/*"."\n";
      	$script_inhalt.="//Sript wurde automatisch angelegt durch Ferengi-Masters Wecker"."\n";
      	$script_inhalt.="//Weckername: $wecker_name_neu"."\n";
      	$script_inhalt.="*/"."\n\n\n\n\n\n\n";
	      $script_inhalt.="?>"."\n";
   	   $fn = IPS_GetKernelDir()."scripts\\".$wecker_name_neu.".ips.php";
      	$handle=fopen($fn,"w");
      	fwrite($handle,$script_inhalt);
      	fclose($handle);

			//Array mit Informationen ber das Objekt
   		$install_arr = IPS_GetObject($IPS_SELF);
			$id_kat		 = $install_arr['ParentID'];

			$id_script 	= IPS_CreateScript(0);
   		IPS_SetParent($id_script, $id_kat);
			IPS_SetScriptFile($id_script, $wecker_name_neu.".ips.php");
	  		IPS_SetName($id_script, $wecker_name_neu);

	     	//Schlummermodus Script
      	$script_inhalt ="<?"."\n";
      	$script_inhalt.="/*"."\n";
      	$script_inhalt.="//Sript wurde automatisch angelegt durch Ferengi-Masters Wecker"."\n";
	      $script_inhalt.="//Schlummermodus-Weckername: $wecker_name_neu"."\n";
   	   $script_inhalt.="*/"."\n\n\n\n\n\n\n";
      	$script_inhalt.="?>"."\n";
      	$fn = IPS_GetKernelDir()."scripts\\".$wecker_name_neu."_Schlummermodus.ips.php";
      	$handle=fopen($fn,"w");
      	fwrite($handle,$script_inhalt);
      	fclose($handle);

			//Array mit Informationen ber das Objekt
   		$install_arr = IPS_GetObject($IPS_SELF);
			$id_kat		 = $install_arr['ParentID'];

			$id_script 	= IPS_CreateScript(0);
   		IPS_SetParent($id_script, $id_kat);
  			IPS_SetScriptFile($id_script, $wecker_name_neu."_Schlummermodus.ips.php");
	  		IPS_SetName($id_script, $wecker_name_neu."_Schlummermodus");

      	return;

	      //---------------------------- Wecker lschen  ------------------------

	      case 'wecker_loe':
   	   $wecker_name = GetValue($id_wecker_name);
	      daten_laden();
   	   $counter = count($wecker_datensatz); // Werte zhlen
      	if($counter < 2)
     	 	{
	        	SetValue($id_wecker_meldung, "Alle Wecker gelscht!");
   			return;
      	}

			//Array mit Informationen ber das Objekt
   		$install_arr = IPS_GetObject($IPS_SELF);
			$id_kat		 = $install_arr['ParentID'];

			$id_script = @IPS_GetScriptIDByName($wecker_name, $id_kat);
			IPS_DeleteScript($id_script, true);

			$id_script = @IPS_GetScriptIDByName($wecker_name."_Schlummermodus", $id_kat);
			IPS_DeleteScript($id_script, true);

      	$i=0;
      	foreach($wecker_datensatz as $value)
      	{
         	if($value == $wecker_name)
         	{
            	$ende = $i+49;
            	for($i; $i < $ende; $i++) unset($wecker_datensatz[$i]);
            	daten_speichern();
            	SetValue($id_wecker_meldung,$wecker_name." gelscht");
            	daten_laden();
            	$wecker_name_counter = 0;
            	SetValue($id_wecker_name, $wecker_datensatz[$wecker_name_counter]);
            	SetValue($id_wecker_name_counter, $wecker_name_counter);
            	$wecker_tag_counter = GetValue($id_wecker_tag_counter);
            	zeit_speichern($wecker_tag_counter);
            	return;
         	}
         	$i=$i+1;
      	}
      	return;
   	}
 	}

 	//--------------------- Wecker aus Funktionsaufruf ndern -------------------

 	//set_wecker(string: "Wecker Name,Tag,Stunde,Minute,bei Feiertag aus,Schlummermodus an/aus,Wecker an/aus");
 	if($IPS_SENDER == "Variable")
 	{
   	$wecker_fkt = GetValue($id_wecker_fkt);
	   $wecker_fkt_arr = explode(",",$wecker_fkt);

	   $wecker_name      = $wecker_fkt_arr[0];
   	$wecker_tag       = $wecker_fkt_arr[1];
   	$wecker_stunde    = $wecker_fkt_arr[2];
   	$wecker_minute    = $wecker_fkt_arr[3];
   	$wecker_feiertag  = $wecker_fkt_arr[4];
   	$wecker_schlummer = $wecker_fkt_arr[5];
   	$wecker_aktiv     = $wecker_fkt_arr[6];

	   daten_laden();

	   //----------------------------- Fehler abfangen --------------------------

	   //Namen prfen
  	 	foreach($wecker_datensatz as $value)
   	{
      	if($value == $wecker_name)
			{
				$name = "gefunden";
				IPS_LogMessage("wecker_fkt_arr[0]","Wecker gefunden");
				break;
			}
   	}
   	if($name != "gefunden")
		{
			IPS_LogMessage("wecker_fkt_arr[0]","Weckerfehler_Name");
			return;
		}

	   //Tag prfen
  	 	if(in_array($wecker_tag, $name_tag))
   	{
      	//Konvention ok
   	}
   	else
   	{
      	IPS_LogMessage("wecker_fkt_arr[1]","Weckerfehler_Tag");
      	return;
   	}

	   //Stunde prfen
   	if(std_test($wecker_stunde))
   	{
     		//Konvention ok
   	}
   	else
   	{
      	IPS_LogMessage("wecker_fkt_arr[2]","Weckerfehler_Stunde");
      	return;
   	}

	   //Minute prfen
   	if(min_test($wecker_minute))
   	{
      	//Konvention ok
   	}
   	else
   	{
      	IPS_LogMessage("wecker_fkt_arr[3]","Weckerfehler_Minute");
      	return;
   	}

	   //Feiertag
   	if(strtolower($wecker_feiertag) == "true")
   	{
      	$wecker_feiertag  = "1";
   	}
   	elseif(strtolower($wecker_feiertag) == "false")
   	{
      	$wecker_feiertag  = "0";
   	}
   	else
   	{
      	IPS_LogMessage("wecker_fkt_arr[4]","Weckerfehler_Feiertag");
      	return;
   	}

   	// Schlummermodus
	   if(strtolower($wecker_schlummer) == "true")
   	{
      	$wecker_schlummer  = "1";
   	}
   	elseif(strtolower($wecker_schlummer) == "false")
   	{
      	$wecker_schlummer  = "0";
   	}
   	else
   	{
      	IPS_LogMessage("wecker_fkt_arr[5]","Weckerfehler_Schlummermodus");
      	return;
   	}

	   // aktiv - prfen
   	if(strtolower($wecker_aktiv) == "true")
   	{
      	$wecker_aktiv  = "1";
   	}
   	elseif(strtolower($wecker_aktiv) == "false")
   	{
      	$wecker_aktiv  = "0";
   	}
   	else
   	{
      	IPS_LogMessage("wecker_fkt_arr[6]","Weckerfehler_Aktiv");
      	return;
   	}

	   $i=0;
   	foreach($wecker_datensatz as $value)
   	{
      	if($value == $wecker_name and $wecker_tag == $wecker_datensatz[$i+1] )
      	{
         	$wecker_datensatz[$i]   = $wecker_name;
         	$wecker_datensatz[$i+1] = $wecker_tag;
         	$wecker_datensatz[$i+2] = $wecker_stunde;
         	$wecker_datensatz[$i+3] = $wecker_minute;
         	$wecker_datensatz[$i+4] = $wecker_feiertag;
         	$wecker_datensatz[$i+5] = $wecker_schlummer;
         	$wecker_datensatz[$i+6] = $wecker_aktiv;
         	daten_speichern();
         	return;
       	}
       	$i=$i+1;
   	}
   	return;
 	}

	//------------------------- Wecker prfen & aktivieren ----------------------

	if(file_exists($filename))
 	{
   	//nix machen
 	}
 	else //erster Datensatz
 	{
   	$wecker_name_neu = "Testwecker";
   	$counter = 0;
   	SetValue($id_wecker_meldung,"Erster Start... Ferengis-Wecker");
   	$counter_merken = $counter;
   	for($tag = 0; $tag < 7; $tag++)
   	{
      	$wecker_datensatz[$counter]   = $wecker_name_neu;
      	$wecker_datensatz[$counter+1] = $name_tag[$tag];
      	$wecker_datensatz[$counter+2] = "10";
      	$wecker_datensatz[$counter+3] = "00";
      	$wecker_datensatz[$counter+4] = false;
      	$wecker_datensatz[$counter+5] = false;
      	$wecker_datensatz[$counter+6] = false;
      	$counter = $counter+7;
   	}
   	daten_speichern();
   	//neuen Wecker anzeigen
   	$counter = $counter_merken;
   	SetValue($id_wecker_name, 				$wecker_datensatz[$counter]);
   	SetValue($id_wecker_tag, 				$wecker_datensatz[$counter+1]);
   	SetValue($id_wecker_stunde, 			$wecker_datensatz[$counter+2]);
   	SetValue($id_wecker_minute, 			$wecker_datensatz[$counter+3]);
   	SetValue($id_wecker_feiertag, 		$wecker_datensatz[$counter+4]);
   	SetValue($id_wecker_schlummer, 		$wecker_datensatz[$counter+5]);
   	SetValue($id_wecker_aktiv, 			$wecker_datensatz[$counter+6]);
   	SetValue($id_wecker_name_counter, 	$counter);
   	return;
 	}

 	daten_laden();
 	$counter = count($wecker_datensatz); // Werte zhlen
 	$i=1; //beim ersten Tag beginnen

	//aktuelle Zeit mit den Weckzeiten vergleichen
 	foreach($wecker_datensatz as $value)
 	{
   	if($wecker_datensatz[$i]   == $tag and
      	$wecker_datensatz[$i+1] == $hrs and
      	$wecker_datensatz[$i+2] == $min and
      	$wecker_datensatz[$i+5] == 1)
  	 	{
      	//bei Feiertag Weckker aus
      	if($wecker_datensatz[$i+3] == 1)
      	{
				//Feiertage
 				class Feiertag
				{
  					function getEasterSundayTime($year)
					{
   					$p = floor($year/100);
   					$r = floor($year/400);
   					$o = floor(($p*8+13)/25)-2;
   					$w = (19*($year%19)+(13+$p-$r-$o)%30)%30;
   					$e = ($w==29?28:$w);
   					if ($w==28&&($year%19)>10) $e=27;
   					$day = (2*($year%4)+4*($year%7)+6*$e+(4+$p-$r)%7)%7+22+$e;
   					$month = ($day>31?4:3);
   					if ($day>31) $day-=31;
   					return mktime(0, 0, 0, $month, $day, $year);
  					}
  					function getHolidays($year)
					{
    					$time = $this->getEasterSundayTime($year);
    					$days["Neujahr"] 							= mktime(0, 0, 0, 1, 1, $year);
			    		//$days["Heilige 3 Knige"] 			= mktime(0, 0, 0, 1, 6, $year);
    					$days["Karfreitag"] 						= $time-(86400*2);
  				  		$days["Ostersonntag"] 					= $time;
    					$days["Tag der Arbeit"] 				= mktime(0, 0, 0, 5, 1, $year);
    					$days["Christi Himmelfahrt"] 			= $time+(86400*39);
    					$days["Pfingstsonntag"] 				= $time+(86400*49);
    					$days["Pfingstmontag"] 					= $time+(86400*50);
    					//$days["Fronleichnam"] 				= $time+(86400*60);
    					//$days["Maria Himmelfahrt"] 			= $time+(86400*60);
    					$days["Tag der deutschen Einheit"] 	= mktime(0, 0, 0, 10, 3, $year);
    					//$days["Reformationstag"] 			= $time+(86400*60);
    					$days["Allerheiligen"] 					= mktime(0, 0, 0, 11, 1, $year);
    					$days["Bu- und Bettag"] 				= $time+(86400*60);
    					$days["1. Weihnachtsfeiertag"] 		= mktime(0, 0, 0, 12, 25, $year);
    					$days["2. Weihnachtsfeiertag"] 		= mktime(0, 0, 0, 12, 26, $year);
    					return $days;
  					}
				}
				if(!isset($year) || empty($year)) $year = date('Y');
				$tag = new Feiertag();
				$days = $tag->getHolidays($year);

	   		foreach($days as $value)
   			{
         		list($key, $value) = each($days);
					//Timestamp von heute
      			$heute      = mktime (0,0,0,date("m"),date("d"),date("y"));
        			//schauen ob Termin auf heute($erg = 0) oder morgen fllt ($erg = -1)
      			$diff       = $heute-$value;
      			$erg        = $diff/((60*60)*24);
	      		//Feiertag gefunden => dann raus
   	   		if ($erg == 0) return;
	   		} //for Schleife beenden
      	}
	     	break; //zur Weckeraktivierung ==>
   	}
   	$i=$i+7;
   	if($i >= $counter) return;
 	}

	//-------------------------------- Weckfunktion -----------------------------

	wecker();

 	//--------------------------------- Funktionen ------------------------------

 	function std_test($std)
 	{
   	if (preg_match("=^[0-9]+$=i",$std))
    	{
      	if($std < 0 or $std >= 24 or $std >= 0 and $std < 10 and strlen($std) !=2)
       	{
         	return false;
       	}
       	else
       	{
         	return true;
       	}
    	}
    	else
    	{
      	return false;
    	}
 	}

	function min_test($min)
 	{
   	if (preg_match("=^[0-9]+$=i",$min))
    	{
      	if($min >= 0 and $min < 10 and strlen($min) !=2)
       	{
         	return false;
       	}
       	else
       	{
         	return true;
       	}
       	return true;
    	}
    	else
    	{
      	return false;
    	}
 	}

	function wecker()
 	{
   	global $wecker_datensatz,$i,$schlummer_zeit;
		//Weckerscript aufrufen
	   include(IPS_GetKernelDir()."scripts\\".$wecker_datensatz[$i-1].".ips.php");
      //Schlummermodus aktivieren
		if($wecker_datensatz[$i+4] == 1)
   	{
      	$st = $wecker_datensatz[$i-1]."_Schlummermodus";
      	IPS_SetScriptTimer($st, (int)$schlummer_zeit*60);
   	}
	}

 	function daten_laden()
 	{
   	global $wecker,$filename,$wecker_datensatz;
   	$wecker = file_get_contents($filename); //Wecker in Variable
   	$wecker_datensatz = explode(",", $wecker); // nach Komma trennen und in array
   	return $wecker_datensatz;
 	}

	function daten_speichern()
 	{
   	global $filename,$wecker_datensatz;
   	$wecker_neu = implode(",", $wecker_datensatz); // in String zurck
   	$handle=fopen($filename, "w");
   	fwrite($handle,$wecker_neu);
   	fclose($handle);
 	}

 	function zeit_speichern($wecker_tag_counter)
 	{
		global $wecker_datensatz,$name_tag,$id_wecker_name,$id_wecker_stunde;
		global $id_wecker_minute,$id_wecker_feiertag,$id_wecker_schlummer;
		global $id_wecker_aktiv;
    	$i=0;
    	$wecker_name = GetValue($id_wecker_name);
    	foreach($wecker_datensatz as $value)
    	{
      	if($value == $name_tag[$wecker_tag_counter] and $wecker_datensatz[$i-1] == $wecker_name)
      	{
         	SetValue($id_wecker_stunde, $wecker_datensatz[$i+1]);
         	SetValue($id_wecker_minute, $wecker_datensatz[$i+2]);
         	SetValue($id_wecker_feiertag, (bool)$wecker_datensatz[$i+3]);
         	SetValue($id_wecker_schlummer, (bool)$wecker_datensatz[$i+4]);
         	SetValue($id_wecker_aktiv, (bool)$wecker_datensatz[$i+5]);
         	return;
      	}
      	$i=$i+1;
    	}
 	}

 	//---------------------------------------------------------------------------

?>